SystemOrganization addCategory: #NautilusWithoutPackages!

Object subclass: #NautilusWithoutPackages
	instanceVariableNames: 'browsedEnvironment ui selectedPackage selectedCategory selectedMethod selectedClass selectedGroup showPackages showGroups showHierarchy showComment showInstance showCategories browsingHistory uiClass announcer plugins'
	classVariableNames: 'AnnotationRequests HistoryMaxSize OpenOnGroups PluginClasses RecentClasses ShowAnnotationPane ShowHierarchy WarningLimit'
	poolDictionaries: ''
	category: 'NautilusWithoutPackages'!

NautilusWithoutPackages class
	instanceVariableNames: 'maxSize cachedLastClasses groups'!

NautilusWithoutPackages class
	instanceVariableNames: 'maxSize cachedLastClasses groups'!

!NautilusWithoutPackages classSide methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
annotationRequests
	"Answer a list of symbol characterizing all the available kinds of annotations; 
	Each symbol represents the info type:
		#timeStamp	: 
			The time stamp of the last submission of the method.
		#firstComment: 
			The first comment in the method, if any.
		#masterComment: 
			The comment at the beginning of the supermost implementor 
			of the method if any.
		#documentation: 
			Comment at beginning of the method or, if it has none, 
			comment at the beginning of a superclass's implementation of the method.
		#messageCategory: 
			Which method category the method lies in.
		#sendersCount: 
			A report of how many senders there of the message.
		#implementorsCount: 
			A report of how many implementors there are of the message.
		#recentChangeSet	: 
			The most recent change set bearing the method.
		#allChangeSets	: 
			A list of all change sets bearing the method.
		#priorVersionsCount: 
			A report of how many previous versions there are of the method.
		#priorTimeStamp: 
			The time stamp of the penultimate submission of the method, if any.
		"
	 ^ AnnotationRequests ifNil: [AnnotationRequests := self defaultAnnotationInfo]! !

!NautilusWithoutPackages classSide methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
annotationRequests: anArray
	"Answer a list of symbol characterizing all the available kinds of annotations; 
	Each symbol represents the info type:
		#timeStamp	: 
			The time stamp of the last submission of the method.
		#firstComment: 
			The first comment in the method, if any.
		#masterComment: 
			The comment at the beginning of the supermost implementor 
			of the method if any.
		#documentation: 
			Comment at beginning of the method or, if it has none, 
			comment at the beginning of a superclass's implementation of the method.
		#messageCategory: 
			Which method category the method lies in.
		#sendersCount: 
			A report of how many senders there of the message.
		#implementorsCount: 
			A report of how many implementors there are of the message.
		#recentChangeSet	: 
			The most recent change set bearing the method.
		#allChangeSets	: 
			A list of all change sets bearing the method.
		#priorVersionsCount: 
			A report of how many previous versions there are of the method.
		#priorTimeStamp: 
			The time stamp of the penultimate submission of the method, if any.
		"
	 AnnotationRequests := anArray! !

!NautilusWithoutPackages classSide methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
browsedEnvironment: anEnvironment

	^ self new browsedEnvironment: anEnvironment! !

!NautilusWithoutPackages classSide methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
buildGroupManager

	| holder |
	holder := GroupsHolder new.
	(holder 
		addADynamicGroupSilentlyNamed: 'Most Viewed Classes' 
		block: [ self recentClassesElements ]) removable: false.
	(holder
		addADynamicGroupSilentlyNamed: 'Last Modified Classes'
		block: [ self lastModifiedClasses ]) removable: false.
	^ holder
			! !

!NautilusWithoutPackages classSide methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
defaultAnnotationInfo
	"see annotationRequests comment"
	^ #(timeStamp messageCategory sendersCount implementorsCount allChangeSets)! !

!NautilusWithoutPackages classSide methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
defaultBrowsedEnvironment

	^ BrowserEnvironment new! !

!NautilusWithoutPackages classSide methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
defaultMaxSize

	^ NavigationHistory defaultMaxSize! !

!NautilusWithoutPackages classSide methodsFor: 'browser compatibility' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
fullOnClass: aClass selector: aSelector 

	aSelector
		ifNil: [ self openOnClass: aClass ]
		ifNotNil: [| method |
			method := aClass methodDict at: aSelector ifAbsent: [ nil ].
			method ifNotNil: [ self openOnMethod: method ]]! !

!NautilusWithoutPackages classSide methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/2/2011 16:56'!
groupsManager

	^ groups ifNil: [ groups := self buildGroupManager ]! !

!NautilusWithoutPackages classSide methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
historyMaxSize

	^ HistoryMaxSize ifNil: [ HistoryMaxSize := self defaultMaxSize ]! !

!NautilusWithoutPackages classSide methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
historyMaxSize: anInteger

	(anInteger isKindOf: Integer) ifFalse: [ ^ self ].
	anInteger > 0 ifFalse: [ ^ self ].
	HistoryMaxSize := anInteger! !

!NautilusWithoutPackages classSide methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 8/2/2011 18:47'!
icon 

	^ AbstractNautilusUIWithoutPackages icon! !

!NautilusWithoutPackages classSide methodsFor: 'groups' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
importAGroup: aGroup

	self groupsManager addAGroup: aGroup! !

!NautilusWithoutPackages classSide methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/2/2011 16:56'!
initialize
	"self initialize"

	groups ifNil: [ groups := self buildGroupManager ]! !

!NautilusWithoutPackages classSide methodsFor: 'groups' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
lastModifiedClasses

	^ cachedLastClasses ifNil: [ cachedLastClasses := RecentMessageList uniqueInstance lastClasses: 10 ]! !

!NautilusWithoutPackages classSide methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
maxSize

	^ maxSize ifNil: [ maxSize := 10]! !

!NautilusWithoutPackages classSide methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
maxSize: anInteger

	maxSize := anInteger.
	self recentClasses maxSize: anInteger.! !

!NautilusWithoutPackages classSide methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 8/2/2011 20:40'!
nautilus2MenuOn: aBuilder 
	"I build a menu"
	<worldMenu>
	(aBuilder item: #Nautilus2WithoutPackages)
		action: [ self new uiClass: NautilusUI2WithoutPackages; open ];
		order: 0;
		help: 'Ready to browse the deeps of the system ?';
		icon: self icon! !

!NautilusWithoutPackages classSide methodsFor: 'settings' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
nautilusSettingsOn: aBuilder
	<systemsettings>
	
	(aBuilder group: #Nautilus)
		target: self;
		label: 'Nautilus' translated;
		description: 'Settings related to the browser' translated;
		with: [
			(aBuilder setting: #openOnGroups)
				label: 'Open the browser on groups ?' translated;
				description: 'If true, Nautilus will show groups when opened' translated ];
		with: [
			(aBuilder setting: #showHierarchy)
				label: 'Show hierarchy by default ?' translated;
				description: 'If false, Nautilus will show a flat list of classes' translated ];
		with: [
			(aBuilder setting: #historyMaxSize)
				label: 'Set the max size of the navigation history' translated;
				description: ('By default, the value is ', self defaultMaxSize printString) translated ];
		with: [
			(aBuilder setting: #warningLimit)
				label: 'Set the warning limit of source code pane' translated;
				description: 'By default, the value is 350' translated ]! !

!NautilusWithoutPackages classSide methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
open
	^ self openInEnvironment: self defaultBrowsedEnvironment! !

!NautilusWithoutPackages classSide methodsFor: 'browser compatibility' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
openBrowserView: aNautilus label: aByteString 
	
	aNautilus open.
	aNautilus ui selectedMethod: aNautilus selectedMethod.
	aNautilus ui update! !

!NautilusWithoutPackages classSide methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
openInEnvironment: anEnvironment

	| instance |
	instance := self new.
	instance browsedEnvironment: anEnvironment.
	instance open.
	^ instance! !

!NautilusWithoutPackages classSide methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
openOnCategory: aCategory ofClass: aClass

	^ self openOnCategory: aCategory ofClass: aClass inEnvironment: self defaultBrowsedEnvironment! !

!NautilusWithoutPackages classSide methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
openOnCategory: aCategory ofClass: aClass inEnvironment: anEnvironment

	| instance |
	instance := self new.
	instance browsedEnvironment: anEnvironment.
	instance showInstance: aClass isMeta not.
	instance showGroups: false.
	instance package: aClass package class: aClass category: aCategory method: nil.
	instance open.
	
	instance ui methodsTree setSelectedNodeItem: aCategory.
	
	^ instance! !

!NautilusWithoutPackages classSide methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
openOnClass: aClass

	^ self openOnClass: aClass inEnvironment: self defaultBrowsedEnvironment! !

!NautilusWithoutPackages classSide methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
openOnClass: aClass inEnvironment: anEnvironment

	| instance |
	instance := self new.
	instance browsedEnvironment: anEnvironment.
	instance showInstance: aClass isMeta not.
	instance showGroups: false.
	instance package: aClass package class: aClass category: nil method: nil.
	instance open.
	instance ui showPackages: false.
	^ instance! !

!NautilusWithoutPackages classSide methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
openOnClass: aClass onGroup: aGroup
	
	^ self openOnClass: aClass onGroup: aGroup inEnvironment: self defaultBrowsedEnvironment.! !

!NautilusWithoutPackages classSide methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
openOnClass: aClass onGroup: aGroup inEnvironment: anEnvironment

	| instance |
	instance := self new.
	instance browsedEnvironment: anEnvironment.
	instance showInstance: aClass isMeta not.
	instance showGroups: true.
	instance selectedGroup: aGroup.
	instance package: aClass package class: aClass category: nil method: nil.
	instance open.
	^ instance! !

!NautilusWithoutPackages classSide methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
openOnGroup: aGroup

	^ self openOnGroup: aGroup inEnvironment: self defaultBrowsedEnvironment! !

!NautilusWithoutPackages classSide methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
openOnGroup: aGroup inEnvironment: anEnvironment

	| instance |
	instance := self new.
	instance browsedEnvironment: anEnvironment.
	instance showGroups: true.
	instance selectedGroup: aGroup.
	instance open.
	^ instance! !

!NautilusWithoutPackages classSide methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
openOnGroups

	^ OpenOnGroups ifNil: [ OpenOnGroups := false ]! !

!NautilusWithoutPackages classSide methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
openOnGroups:aBoolean

	OpenOnGroups := aBoolean! !

!NautilusWithoutPackages classSide methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
openOnMethod: aMethod
	
	^ self openOnMethod: aMethod inEnvironment: self defaultBrowsedEnvironment! !

!NautilusWithoutPackages classSide methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 8/2/2011 20:39'!
openOnMethod: aMethod inEnvironment: anEnvironment

	| instance class |
	class := aMethod methodClass.
	instance := self new.
	instance browsedEnvironment: anEnvironment.
	instance showInstance: class isMeta not.
	instance showGroups: false.
	instance package: class theNonMetaClass category class: class category: aMethod protocol asString method: aMethod.
	instance open.
	
	instance ui forceSelection: aMethod protocol.
	instance ui forceSelection: aMethod.
	
	^ instance! !

!NautilusWithoutPackages classSide methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
openOnPackage: aPackage

	^ self openOnPackage: aPackage inEnvironment: self defaultBrowsedEnvironment! !

!NautilusWithoutPackages classSide methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
openOnPackage: selectedPackage class: selectedClass category: selectedCategory method: selectedMethod group: selectedGroup showGroups: showGroups showHierarchy: showHierarchy showPackages: showPackages showComment: showComment  showInstance: showInstance showCategories: showCategories

	^ self openOnPackage: selectedPackage class: selectedClass category: selectedCategory method: selectedMethod group: selectedGroup showGroups: showGroups showHierarchy: showHierarchy showPackages: showPackages showComment: showComment  showInstance: showInstance showCategories: showCategories inEnvironment: self defaultBrowsedEnvironment! !

!NautilusWithoutPackages classSide methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
openOnPackage: selectedPackage class: selectedClass category: selectedCategory method: selectedMethod group: selectedGroup showGroups: showGroups showHierarchy: showHierarchy showPackages: showPackages showComment: showComment  showInstance: showInstance showCategories: showCategories inEnvironment: anEnvironment

	| instance |
	instance := self new.
	instance browsedEnvironment: anEnvironment.
	
	instance package: selectedPackage class: selectedClass category: selectedCategory method: selectedMethod.
	instance selectedGroup: selectedGroup.	
	instance
		showGroups: showGroups;
		showHierarchy: showHierarchy;
		showComment: showComment;
		showInstance: showInstance;
		showCategories: showCategories.
	
	instance open.
	instance ui showPackages: showPackages.
	instance ui forceSelection: selectedCategory.
	instance ui forceSelection: selectedMethod.

	^ instance! !

!NautilusWithoutPackages classSide methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
openOnPackage: aPackage inEnvironment: anEnvironment

	| instance |
	instance := self new.
	instance browsedEnvironment: anEnvironment.
	instance showGroups: false.
	instance selectedPackage: aPackage.
	instance open.
	^ instance! !

!NautilusWithoutPackages classSide methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
pluginClasses

	^ PluginClasses ifNil: [ PluginClasses := OrderedCollection new ].! !

!NautilusWithoutPackages classSide methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
pluginClasses: aCollection

	PluginClasses := aCollection! !

!NautilusWithoutPackages classSide methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
pluginClassesAdd: aClass

	self pluginClasses add: aClass! !

!NautilusWithoutPackages classSide methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
recentClasses

	^ RecentClasses ifNil: [ RecentClasses := HistoryCollection maxSize: self maxSize ]! !

!NautilusWithoutPackages classSide methodsFor: 'groups' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
recentClassesElements

	^ self recentClasses mostViewedlements! !

!NautilusWithoutPackages classSide methodsFor: 'groups' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
resetCachedLastClasses

	^ cachedLastClasses := nil! !

!NautilusWithoutPackages classSide methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
showAnnotationPane: aBoolean

	ShowAnnotationPane := aBoolean! !

!NautilusWithoutPackages classSide methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
showHierarchy

	^ ShowHierarchy ifNil: [ ShowHierarchy := true ]! !

!NautilusWithoutPackages classSide methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
showHierarchy: aBoolean

	ShowHierarchy := aBoolean! !

!NautilusWithoutPackages classSide methodsFor: 'events' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
stopNotifications
	" self stopNotifications "
	SystemChangeNotifier uniqueInstance noMoreNotificationsFor: self! !

!NautilusWithoutPackages classSide methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
warningLimit

	^ WarningLimit ifNil: [ WarningLimit := 350 ]! !

!NautilusWithoutPackages classSide methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
warningLimit: anInteger

	WarningLimit := anInteger! !

!NautilusWithoutPackages methodsFor: 'comparing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
= aNautilus

	self class = aNautilus class ifFalse: [ ^ false ].
	1 to: self class instVarNames size do: [:index |
		(self instVarAt: index) = (aNautilus instVarAt: index)
			ifFalse: [ ^ false ]].
	^ true! !

!NautilusWithoutPackages methodsFor: 'history' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
adopt: anAssociation

	| nautilusWrapper |
	nautilusWrapper := anAssociation key.
	self ui ifNotNil: [:interface |
		interface resetSelections].
	self
		selectedPackage: nautilusWrapper selectedPackage;
		selectedCategory: nautilusWrapper selectedCategory.
		nautilusWrapper selectedMethod
			ifNil: [ self selectedMethod: nil ]
			ifNotNil: [:sel | self selectedMethod: ( nautilusWrapper selectedClass>>sel )].
	self
		selectedClass: nautilusWrapper selectedClass;
		selectedGroup: nautilusWrapper selectedGroup;
		showPackages: nautilusWrapper showPackages;
		showGroups: nautilusWrapper showGroups;
		showHierarchy: nautilusWrapper showHierarchy;
		showComment: nautilusWrapper showComment;
		showInstance: nautilusWrapper showInstance;
		showCategories: nautilusWrapper showCategories.
		
	self ui ifNotNil: [:interface |
		interface showPackages: self showPackages.
		interface forceSelection: self selectedCategory.
		interface forceSelection: self selectedMethod.
		interface updateBothView.
		interface update].! !

!NautilusWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
annotationRequests

	^ self class annotationRequests! !

!NautilusWithoutPackages methodsFor: 'announcement' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
announcer

	^ announcer ifNil: [ announcer := NautilusAnnouncer new ]! !

!NautilusWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
browsedEnvironment

	^ browsedEnvironment ifNil: [ browsedEnvironment := BrowserEnvironment new ]! !

!NautilusWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
browsedEnvironment: anEnvironment

	browsedEnvironment := anEnvironment! !

!NautilusWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
browsingHistory

	^ browsingHistory ifNil: [ browsingHistory := NavigationHistory new ]! !

!NautilusWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
classes
	
	^ self browsedEnvironment classes! !

!NautilusWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
classesInTheSelectedPackage

	^ self selectedPackage
		ifNil: [{}]
		ifNotNil: [:package | 
			(package definedClasses asArray sort: [:a :b | a name <= b name]), (package extendedClasses asArray sort: [:a :b | a name <= b name])]! !

!NautilusWithoutPackages methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 8/2/2011 20:39'!
defaultUIClass

	^ NautilusUI2WithoutPackages! !

!NautilusWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
foundExtentionsIn: aClass

	| result |
	result :=  aClass extendingPackages.
	"self haltIf: [result isEmpty not]."
	^ result! !

!NautilusWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
groupsManager
	
	^ self class groupsManager! !

!NautilusWithoutPackages methodsFor: 'history' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
hasNext
	
	^self browsingHistory hasNext! !

!NautilusWithoutPackages methodsFor: 'history' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
hasPrevious
	
	^self browsingHistory hasPrevious! !

!NautilusWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
initialize

	super initialize.
	plugins := OrderedCollection new.
	self class pluginClasses do: [:each |
		plugins add: (each model: self)]! !

!NautilusWithoutPackages methodsFor: 'browser compatibility' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
labelString

	^ self ui
		ifNil: [ 'Nautilus' ]
		ifNotNil: [:UI | UI title ]! !

!NautilusWithoutPackages methodsFor: 'history' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
next

	self adopt: self browsingHistory next.
	self triggerEvent: #historyChanged.! !

!NautilusWithoutPackages methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 8/2/2011 20:39'!
open

	ui := (self uiClass on: self) open! !

!NautilusWithoutPackages methodsFor: 'browser compatibility' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
openEditString: aString 

	" Dunno what to do"! !

!NautilusWithoutPackages methodsFor: 'history' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
package: aPackage class: aClass category: aCategory method: aMethod

	self 
		selectedPackage: aPackage;
		selectedClass: aClass;
		selectedCategory: aCategory;
		selectedMethod: aMethod.
		
	self registerHistoryNewEntry.! !

!NautilusWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:44'!
packages

	^ self browsedEnvironment categories! !

!NautilusWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:59'!
packagesUsedByTheSelectedClass

	| result class |

	result := OrderedCollection new.
	class := self selectedClass.
	
	class ifNil: [^{}].
	result add: class cateogory.
	result addAll: (self foundExtentionsIn: class).
	result := result intersection: self packages.
	^ result select:[:each | each notNil]! !

!NautilusWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
plugins

	^ plugins ifNil: [ plugins := OrderedCollection new ]! !

!NautilusWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
plugins: aCollection

	plugins := aCollection! !

!NautilusWithoutPackages methodsFor: 'history' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
previous

	self adopt: self browsingHistory previous.
	self triggerEvent: #historyChanged.! !

!NautilusWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
recentClasses

	^ self class recentClasses! !

!NautilusWithoutPackages methodsFor: 'history' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
registerHistoryNewEntry

	| wrapper |
	wrapper := NautilusWrapper with: self.
	self browsingHistory add: wrapper.
	self triggerEvent: #historyChanged.
	"should take care of ui's"! !

!NautilusWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
selectedCategory

	^ selectedCategory! !

!NautilusWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
selectedCategory: anObject

	selectedCategory := anObject.
	self announcer announce: ( NautilusCategorySelected category: anObject )! !

!NautilusWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
selectedClass

	^ selectedClass! !

!NautilusWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
selectedClass: aClass

	selectedClass := aClass.
	aClass ifNotNil: [ self recentClasses add: aClass theNonMetaClass ].
	self announcer announce: ( NautilusClassSelected class: aClass )! !

!NautilusWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
selectedGroup

	^ selectedGroup! !

!NautilusWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
selectedGroup: anObject

	selectedGroup := anObject.
	self announcer announce: ( NautilusGroupSelected group: anObject )! !

!NautilusWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
selectedMethod

	^ selectedMethod! !

!NautilusWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
selectedMethod: anObject

	selectedMethod := anObject.
	self announcer announce: ( NautilusMethodSelected method: anObject )! !

!NautilusWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
selectedPackage

	^ selectedPackage! !

!NautilusWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
selectedPackage: anObject

	selectedPackage := anObject.
	self announcer announce: ( NautilusPackageSelected package: anObject )! !

!NautilusWithoutPackages methodsFor: 'browser compatibility' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
setClass: aClass selector: aSelector 
	
	| method protocol |
	method := aClass methodDict at: aSelector ifAbsent: [ nil ].
	protocol := method 
					ifNil: [ nil ]
					ifNotNil: [ method protocol ].
	self 
		showGroups: false;
		selectedPackage: aClass package;
		selectedClass: aClass;
		showInstance: aClass isMeta not;
		selectedCategory: protocol;
		selectedMethod: method
	! !

!NautilusWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
shouldOpenOnGroups

	^ self class openOnGroups and: [ self class groupsManager isEmpty not ]! !

!NautilusWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
showCategories

	^ showCategories ifNil: [ showCategories := true ]! !

!NautilusWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
showCategories: aBoolean

	showCategories := aBoolean.
	self announcer announce: ( NautilusShowCategoriesChanged boolean: aBoolean )! !

!NautilusWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
showComment

	^ showComment ifNil: [ showComment := false ]! !

!NautilusWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
showComment: aBoolean

	showComment := aBoolean.
	self announcer announce: ( NautilusShowCommentChanged boolean: aBoolean )! !

!NautilusWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
showGroups

	^ showGroups ifNil: [ showGroups := self shouldOpenOnGroups ]! !

!NautilusWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/2/2011 16:29'!
showGroups: aBoolean

	showGroups := aBoolean.
	"self announcer announce: ( NautilusShowGroupsChanged boolean: aBoolean )"! !

!NautilusWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
showHierarchy

	^ showHierarchy ifNil: [ showHierarchy := self class showHierarchy ]! !

!NautilusWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
showHierarchy: aBoolean

	showHierarchy := aBoolean.
	self announcer announce: ( NautilusShowHierarchyChanged boolean: aBoolean )! !

!NautilusWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
showInstance

	^ showInstance ifNil: [ showInstance := true ]! !

!NautilusWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
showInstance: aBoolean

	showInstance := aBoolean.
	self announcer announce: ( NautilusShowInstanceChanged boolean: aBoolean )! !

!NautilusWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
showPackages

	^ showPackages ifNil: [ showPackages := true ]! !

!NautilusWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
showPackages: aBoolean

	showPackages := aBoolean.
	self announcer announce: ( NautilusShowPackagesChanged boolean: aBoolean )! !

!NautilusWithoutPackages methodsFor: 'browser compatibility' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
spawnHierarchy

	self 
		showHierarchy:true;
		open.
	self ui showPackages: false! !

!NautilusWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
ui

	^ ui! !

!NautilusWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
uiClass

	^ uiClass ifNil: [ self defaultUIClass ]! !

!NautilusWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
uiClass: aClass

	uiClass := aClass! !

!NautilusWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
warningLimit

	^ self class warningLimit! !

AbstractTool subclass: #AbstractNautilusUIWithoutPackages
	instanceVariableNames: 'model window hierarchyClass cachedHierarchy sourceTextArea firstColumn secondColumn groupsSelection packagesSelection classesSelection list list2 sourceCodePanel commentTextArea currentDisplayChoice sourceTextAreaLimit'
	classVariableNames: 'ClassesIconsCache GroupsIconsCache Icon MethodsIconsCache PackagesIconsCache'
	poolDictionaries: ''
	category: 'NautilusWithoutPackages'!

!AbstractNautilusUIWithoutPackages classSide methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
buildIcon

	| bitmap |
	bitmap :=  (Bitmap new: 256) copyFromByteArray:   #[0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 255 249 235 15 254 248 233 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 183 102 33 13 162 147 126 14 199 176 153 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 143 187 142 101 94 197 140 89 0 0 0 0 208 181 135 93 108 190 134 85 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 144 159 121 84 174 168 127 90 119 181 140 104 194 182 128 81 24 207 148 99 4 252 255 255 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 159 170 119 70 255 200 124 58 253 189 122 63 60 148 118 91 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 199 157 91 59 255 222 129 64 255 201 118 48 178 152 100 49 73 138 112 54 106 168 135 62 167 206 169 100 193 191 158 105 115 172 143 97 0 0 0 0 5 155 136 98 55 204 190 157 10 236 223 187 0 0 0 0 21 105 87 68 91 162 123 78 240 187 126 60 255 212 131 43 253 227 148 48 255 218 157 63 255 233 175 78 255 235 176 64 255 224 167 68 255 232 171 81 255 216 168 74 109 181 145 85 21 154 136 98 245 194 174 137 33 211 209 190 81 172 145 107 241 194 152 81 255 207 158 80 255 243 176 64 254 246 176 67 254 208 141 49 255 221 156 81 255 200 123 54 255 209 137 56 255 187 124 56 254 204 128 48 255 248 183 62 230 171 125 65 0 0 0 0 198 196 161 122 135 198 161 130 238 191 139 90 255 227 158 63 254 234 165 51 254 244 172 65 255 227 160 65 254 170 105 26 255 209 144 65 254 185 117 40 253 213 143 55 252 221 143 58 248 238 144 58 255 223 134 39 250 163 97 51 20 231 255 255 185 186 137 106 255 181 122 80 255 162 85 36 255 221 124 53 255 234 154 50 255 234 170 61 255 232 168 69 255 220 149 53 255 238 159 56 255 241 163 59 255 231 158 59 255 226 151 64 255 198 120 54 215 166 91 43 57 133 68 38 13 210 220 210 83 199 158 129 209 203 160 125 129 184 139 102 235 161 83 47 255 190 102 41 255 203 112 40 255 208 117 47 253 213 121 50 251 208 122 55 222 185 106 44 175 159 100 50 139 141 103 65 53 156 105 65 9 99 69 79 0 0 0 0 0 0 0 0 0 0 0 0 143 155 129 114 0 0 0 0 10 138 135 170 65 108 49 22 87 138 77 48 93 129 70 41 45 93 34 6 26 68 32 26 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 197 179 174 0 0 0 0 93 197 180 176 4 202 182 170 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 180 88 18 2 146 92 49 1 128 100 73 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0].
	^ Form extent: 16@16 depth: 32 bits: bitmap! !

!AbstractNautilusUIWithoutPackages classSide methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
icon 

	^ Icon ifNil: [ Icon := self buildIcon ]! !

!AbstractNautilusUIWithoutPackages classSide methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
initialize

	" self initialize "
	super initialize.
	ClassesIconsCache := Dictionary new.
	GroupsIconsCache := Dictionary new.
	MethodsIconsCache := Dictionary new.
	PackagesIconsCache := Dictionary new.! !

!AbstractNautilusUIWithoutPackages classSide methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
on: aNautilus

	^ self new model: aNautilus! !

!AbstractNautilusUIWithoutPackages classSide methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
resetIcon

	Icon := nil! !

!AbstractNautilusUIWithoutPackages methodsFor: 'group announcements' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
aGroupHasBeenAdded: anAnnouncement
	 "(NautilusUI methodDict at: #aGroupHasBeenRegistered:) getSource"

	| group |
	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [^ self ].
	self showGroups ifFalse: [ ^ self ].
	group := anAnnouncement group.
	(self groupsManager includes: group)
		ifTrue: [ self updateGroupView ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'group announcements' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
aGroupHasBeenRegistered: anAnnouncement
	 "(NautilusUI methodDict at: #aGroupHasBeenRegistered:) getSource"

	| group |
	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [^ self ].
	self showGroups ifFalse: [ ^ self ].
	group := anAnnouncement group.
	(self groupsManager includes: group)
		ifTrue: [ self updateGroupView ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'group announcements' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
aGroupHasBeenRemoved: anAnnouncement
	 "(NautilusUI methodDict at: #aGroupHasBeenRegistered:) getSource"

	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [^ self ].
	self showGroups ifFalse: [ ^ self ].
	(self groupsManager =  anAnnouncement holder)
		ifTrue: [ 
			self selectedGroup = anAnnouncement group
				ifTrue: [ self selectedGroup: nil ].
			self updateGroupView.
			self update ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'group announcements' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
aGroupHasBeenRenamed: anAnnouncement
	 "(NautilusUI methodDict at: #aGroupHasBeenRegistered:) getSource"

	| group |
	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [^ self ].
	self showGroups ifFalse: [ ^ self ].
	group := anAnnouncement group.
	(self groupsManager includes: group)
		ifTrue: [ self updateGroupView ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'group announcements' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
aGroupHasBeenUnregistered: anAnnouncement

	| group |
	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [^ self ].
	self showGroups ifFalse: [ ^ self ].
	group := anAnnouncement group.
	(self groupsManager includes: group)
		ifTrue: [ self updateGroupView ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'plugins announcements' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
aKeyHasBeenPressed: aKey

	self announcer announce: (NautilusKeyPressed key: aKey )! !

!AbstractNautilusUIWithoutPackages methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
addAll: aWindow
	
	self subclassResponsibility! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
addCategory
	^ self subclassResponsibility! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
addClass

	self selectedPackage ifNotNil: [:package | self addClassIn: package ]
	
	" No need of update, announcements will do the job "! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
addClassInGroup

	self selectedClass ifNotNil: [:class | self addClassInGroup: class ].! !

!AbstractNautilusUIWithoutPackages methodsFor: 'group' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
addClassInGroup: aClass

	(DialogGroupAdder new
		groups:	self groupsManager;
		elementsToAdd: { aClass })
		open! !

!AbstractNautilusUIWithoutPackages methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
addComment: aText notifying: aController

	self selectedClass
		ifNil: [
			self selectedPackage
				ifNotNil: [:package | 
					"commentTextArea update: #clearUserEdits.
					package comment: aText"]]
		ifNotNil: [:class |
			commentTextArea update: #clearUserEdits.
			class comment: aText ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
addModelItemsToWindowMenu: aMenu
	"Add model-related items to the window menu"
	"super addModelItemsToWindowMenu: aMenu."
	SystemBrowser addRegistryMenuItemsTo: aMenu inAccountOf: self model.

	aMenu addLine;
		add: 'Nautilus Plugins Manager'
		target: NautilusPluginManager new
		action: #openInWorld.! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
addPackage

	| package |
	package := self addPackageBasedOn: self selectedPackage.
	package ifNotNil: [
			self selectedPackage: package.
			self updatePackageView ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
addPackageAsGroup

	^ self addPackagesAsGroup: self selectedPackages! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
addPackageAsGroupAndBrowse

	self addPackageAsGroup
		ifNotNil: [:group | 
			self selectedGroup: group.
			self showGroups: true]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
addPackageInGroup
	
	self addPackagesInGroup: self selectedPackages! !

!AbstractNautilusUIWithoutPackages methodsFor: 'group' stamp: 'BenjaminVanRyseghem 8/2/2011 17:00'!
addPackagesAsGroup: aCollection

	aCollection
		ifNotEmpty: [| packages blocks name | 
			packages := aCollection sort: [:a :b | a name <= b name ].
			blocks := OrderedCollection new.
			packages do: [:package | blocks add: [ self classesForPackage: package ]].
			name := ( packages collect: [:package | package asString ]) joinUsing: ' + '.
			^ (self groupsManager	
					addADynamicGroupSilentlyNamed: name
					blocks: blocks)]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'group' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
addPackagesInGroup: aCollection
	
	aCollection
		ifNotEmpty: [:packages || classes |
			classes := packages gather: [:package | package classes ].
			(DialogGroupAdder new
				groups:	self groupsManager;
				elementsToAdd: (self model classes intersection: classes))
				open]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
addSubclassesOf: aClass in: result withIndex: index

	(aClass subclasses sort: [:a :b| a name <= b name]) do: [:each |
		result add: each -> index.
		self addSubclassesOf: each in: result withIndex: index + 1]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
addSubclassesOf: aClass in: result withIndex: index fromRestrictedCollection: aCollection

	| classes |
	
	classes := aClass subclasses intersection: aCollection.
	(classes sort: [:a :b| a name <= b name]) do: [:each |
		result add: each -> index.
		self addSubclassesOf: each in: result withIndex: index + 1 fromRestrictedCollection: aCollection]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
addTrait

	self selectedPackage ifNotNil: [:package | self addTraitIn: package ]
	
	" No need of update, announcements will do the job "! !

!AbstractNautilusUIWithoutPackages methodsFor: 'annotation pane' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
annotation

	|  aSelector aClass |
	(aClass := self selectedClass) == nil ifTrue: [^ '------'].

	(aSelector := self selectedMethod ) ifNil: [^ '------'].
	aSelector := aSelector selector.
	^ self annotationForSelector: aSelector ofClass: aClass! !

!AbstractNautilusUIWithoutPackages methodsFor: 'annotation pane' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
annotationForSelector: aSelector ofClass: aClass 
	"Provide a line of content for an annotation pane, representing  
	information about the given selector and class"
	| separator aStream requestList |
	
	aStream := ReadWriteStream on: ''.
	requestList := self annotationRequests.
	separator := requestList size > 1
				ifTrue: [self annotationSeparator]
				ifFalse: [''].
	requestList
		do: [:aRequest | | sendersCount aComment implementorsCount aString aList stamp aCategory | 
			aRequest == #firstComment
				ifTrue: [aComment := aClass firstCommentAt: aSelector.
					aComment isEmptyOrNil
						ifFalse: [aStream nextPutAll: aComment , separator]].
			aRequest == #masterComment
				ifTrue: [aComment := aClass supermostPrecodeCommentFor: aSelector.
					aComment isEmptyOrNil
						ifFalse: [aStream nextPutAll: aComment , separator]].
			aRequest == #documentation
				ifTrue: [aComment := aClass precodeCommentOrInheritedCommentFor: aSelector.
					aComment isEmptyOrNil
						ifFalse: [aStream nextPutAll: aComment , separator]].
			aRequest == #timeStamp
				ifTrue: [stamp := self selectedMethod 
									ifNil: ['']
									ifNotNil: [:meth | meth timeStamp].
					aStream
						nextPutAll: (stamp size > 0
								ifTrue: [stamp , separator]
								ifFalse: ['no timeStamp' , separator])].
			aRequest == #messageCategory
				ifTrue: [aCategory := aClass organization categoryOfElement: aSelector.
					aCategory
						ifNotNil: ["woud be nil for a method no longer present,  
							e.g. in a recent-submissions browser"
							aStream nextPutAll: aCategory , separator]].
			aRequest == #sendersCount
				ifTrue: [sendersCount := (self systemNavigation allCallsOn: aSelector) size.
					sendersCount := sendersCount == 1
								ifTrue: ['1 sender']
								ifFalse: [sendersCount printString , ' senders'].
					aStream nextPutAll: sendersCount , separator].
			aRequest == #implementorsCount
				ifTrue: [implementorsCount := self systemNavigation numberOfImplementorsOf: aSelector.
					implementorsCount := implementorsCount == 1
								ifTrue: ['1 implementor']
								ifFalse: [implementorsCount printString , ' implementors'].
					aStream nextPutAll: implementorsCount , separator].
			aRequest == #priorVersionsCount
				ifTrue: [self
						addPriorVersionsCountForSelector: aSelector
						ofClass: aClass
						to: aStream].
			aRequest == #priorTimeStamp
				ifTrue: [stamp := VersionsBrowser
								timeStampFor: aSelector
								class: aClass
								reverseOrdinal: 2.
					stamp
						ifNotNil: [aStream nextPutAll: 'prior time stamp: ' , stamp , separator]].
			aRequest == #recentChangeSet
				ifTrue: [aString := ChangeSet mostRecentChangeSetWithChangeForClass: aClass selector: aSelector.
					aString size > 0
						ifTrue: [aStream nextPutAll: aString , separator]].
			aRequest == #allChangeSets
				ifTrue: [aList := ChangeSet allChangeSetsWithClass: aClass selector: aSelector.
					aList size > 0
						ifTrue: [aList size = 1
								ifTrue: [aStream nextPutAll: 'only in change set ']
								ifFalse: [aStream nextPutAll: 'in change sets: '].
							aList
								do: [:aChangeSet | aStream nextPutAll: aChangeSet name , ' ']]
						ifFalse: [aStream nextPutAll: 'in no change set'].
					aStream nextPutAll: separator]].
	^ aStream contents! !

!AbstractNautilusUIWithoutPackages methodsFor: 'annotation pane' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
annotationRequests
	^ self model annotationRequests! !

!AbstractNautilusUIWithoutPackages methodsFor: 'annotation pane' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
annotationSeparator
	"Answer the separator to be used between annotations"

	^ '  '! !

!AbstractNautilusUIWithoutPackages methodsFor: 'announcement registration' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
announcer

	^ self model announcer! !

!AbstractNautilusUIWithoutPackages methodsFor: 'icons behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
arrowDown: aMethod

	| methods methodsNames index |
	methods := aMethod methodClass allSubclasses gather: [:each | each methodDict values ].
	methods := methods select: [:each | each selector = aMethod selector ].
	methods size = 1
		 ifTrue: [ ^ self model class openOnMethod: methods first ].
	methodsNames := methods collect: [:each | each methodClass name, '>>#', each selector ].
	index := UIManager default chooseFrom: methodsNames.
	index = 0 ifTrue: [ ^ self ].
	^ self model class openOnMethod: (methods at: index)
	! !

!AbstractNautilusUIWithoutPackages methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
arrowKey2: aCharacter from: aPluggableListMorph 

	aCharacter == $f
		ifTrue: [
			^ self 
				ifPackages: [ self findMethod ]
				ifClasses:[ self findClass ]].
			
	aCharacter == $F
		ifTrue: [
			^ self 
				ifPackages: [ self findClass ]
				ifClasses:[ self findPackage ]].

	aCharacter == $b
		ifTrue: [ ^ self fullBrowse ].

	aCharacter == $N
		ifTrue: [ 
			self showPackages
				ifTrue: [ self browseClassRefs ]].
			
	aCharacter == $t
		ifTrue: [
			self showPackages
				ifTrue: [ self runClassTests ]].
			
		
	aCharacter == $B
		ifTrue: [
			^ self 
				ifPackages: [ self restrictedBrowseClass ]
				ifClasses:[ self restrictedBrowsePackage ]].

	aCharacter == $N
		ifTrue: [
			^ self 
				ifPackages: [  ]
				ifClasses:[ self browseClassRefs ]].
			
	aCharacter == $n
		ifTrue: [
			self showGroups
				ifFalse: [
					self 
						ifPackages: [ ^ self addClass ]
						ifClasses:[ ^ self addPackage ]]].

	(aCharacter == $r and: [ self selectedClasses size <= 1 ])
		ifTrue: [
			^ self 
				ifPackages: [ self renameClass ]
				ifClasses:[ self renamePackage ]].
				
	aCharacter == $x
		ifTrue: [
			^self 
				ifPackages: [ self removeClasses ]
				ifClasses:[ self removePackage ]].
			
	aCharacter == $c
		ifTrue: [
			self showPackages
				ifTrue: [ ^ self copyClass ]].
	
	aCharacter == $g
		ifTrue: [
			self 
				ifPackages: [  ]
				ifClasses:[ ^ self addPackageAsGroupAndBrowse ]].
				
	aCharacter == $G
		ifTrue: [
			self 
				ifPackages: [  ]
				ifClasses:[ ^ self addPackageAsGroup ]].
				
	aCharacter == $e
		ifTrue: [
			self showGroups
				ifFalse: [
					self 
						ifPackages: [ ^ self addClassInGroup ]
						ifClasses:[ ^ self addPackageInGroup ]]].! !

!AbstractNautilusUIWithoutPackages methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
arrowKey: aCharacter from: aPluggableListMorph 

	aCharacter == $f
		ifTrue: [
			^ self 
				ifPackages: [ self findClass ]
				ifClasses:[ self findMethod ]].

	(aCharacter == $F and: [ self showGroups not ])
		ifTrue: [
			^ self 
				ifPackages: [ self findPackage ]
				ifClasses:[ self findClass ]].
				
	aCharacter == $t
		ifTrue: [
			self showPackages
				ifFalse: [ self runClassTests ]].

	aCharacter == $b
		ifTrue: [ ^ self fullBrowse ].

	aCharacter == $B
		ifTrue: [
			^ self showGroups
				ifTrue: [ self restrictedBrowseGroup: self selectedGroups ]
				ifFalse: [
					self 
						ifPackages: [ self restrictedBrowsePackage ]
						ifClasses:[ self restrictedBrowseClass ]]].
				
	aCharacter == $N
		ifTrue: [ 
			self showPackages
				ifFalse: [ self browseClassRefs ]].

	(aCharacter == $r and: [ self enableSingleMenuItems ])
		ifTrue: [
			^ self showGroups
				ifTrue: [ self renameGroup ]
				ifFalse: [
					self 
						ifPackages: [ self renamePackage ]
						ifClasses:[ self renameClass ]]].
				
	aCharacter == $x
		ifTrue: [
			self showGroups
				ifTrue: [ self removeGroup ]
				ifFalse: [
					self 
						ifPackages: [ self removePackage ]
						ifClasses:[ self removeClasses ]]].
				
	aCharacter == $c
		ifTrue: [
			self showPackages
				ifFalse: [ ^ self copyClass ]].
	
	aCharacter == $g
		ifTrue: [
			self showGroups
				ifFalse: [
					self 
						ifPackages: [ ^ self addPackageAsGroupAndBrowse ]
						ifClasses:[ ]]].
	aCharacter == $n
		ifTrue: [
			self showGroups
				ifFalse: [
					self 
						ifPackages: [ ^ self addPackage ]
						ifClasses:[ ^ self addClass ]]].
							
	aCharacter == $G
		ifTrue: [
			self showGroups
				ifFalse: [
					self 
						ifPackages: [ ^ self addPackageAsGroup ]
						ifClasses:[ ]]].
				
	aCharacter == $e
		ifTrue: [
			self showGroups
				ifFalse: [
					self 
						ifPackages: [ ^ self addPackageInGroup ]
						ifClasses:[ ^ self addClassInGroup ]]].! !

!AbstractNautilusUIWithoutPackages methodsFor: 'icons behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
arrowUp: aMethod

	| newMethod |
	newMethod := aMethod methodClass superclass lookupSelector: aMethod selector.
	self model class openOnMethod: newMethod! !

!AbstractNautilusUIWithoutPackages methodsFor: 'icons behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
arrowUpAndDown: aMethod! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
asYetUnclassifiedString

	^ ClassOrganizer default! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
browseClassRefs

	self browseClassRefsOf: self selectedClass
! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
browseClassVarRefs

	self browseClassVarRefsOf: self selectedClass! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
browseClassVars

	| cls |
	cls := self selectedClass theNonMetaClass.
	(cls notNil and: [cls isTrait not])
		ifTrue: [self systemNavigation browseClassVarRefs: cls]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
browseInstVarDefs 

	self browseInstVarDefsOf: self selectedClass! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
browseInstVarRefs 

	self browseInstVarRefsOf: self selectedClass! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
browseInstVars

	| cls |
	cls := self selectedClass.
	(cls notNil and: [cls isTrait not])
		ifTrue: [self systemNavigation browseInstVarRefs: cls]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
browseMessages

	self browseMessagesFrom: self selectedMethod! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
browseSendersOfMessages
	"Present a menu of the currently selected message, as well as all messages sent by it.  Open a message set browser of all senders of the selector chosen."

	self browseSendersOfMessagesFrom: self selectedMethod! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
browseUnusedMethods
	
	self browseUnusedMethodsOf: self selectedClass! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
browseVersions
	"Create and schedule a Versions Browser, showing all versions of the 
	currently selected message. Answer the browser or nil."

	self browseVersionsFrom: self selectedMethod! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
browsedEnvironment

	^ self model browsedEnvironment! !

!AbstractNautilusUIWithoutPackages methodsFor: 'plugins display' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
buildBottomPlugins
	^ self subclassResponsibility! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
buildBrowseClassVarsButton

	^ ToogleIconicButton new
			model: self;
			actionSelector: #browseClassVars;
			color: Color transparent;
			extent: 24@24;
			borderWidth: 0;
			statusSelector: #isAClassSelected;
			enabledIcon: (NautilusIcons iconNamed: #classVarsSelectedIcon);
			disabledIcon: (NautilusIcons iconNamed: #classVarsUnselectedIcon);
			helpText: 'Show class variables'.! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
buildBrowseInstVarsButton

	^ ToogleIconicButton new
			model: self;
			actionSelector: #browseInstVars;
			color: Color transparent;
			extent: 24@24;
			borderWidth: 0;
			statusSelector: #isAClassSelected;
			enabledIcon: (NautilusIcons iconNamed: #instVarsSelectedIcon);
			disabledIcon: (NautilusIcons iconNamed: #instVarsUnselectedIcon);
			helpText: 'Show instance variables'.! !

!AbstractNautilusUIWithoutPackages methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
buildCodePane

	sourceTextArea := self textMorphClass
				on: self
				text: #sourceCode
				accept: #compileSource:notifying:
				readSelection: #contentsSelection
				menu: #codePaneMenu:shifted:.
				
	sourceTextArea beStyled.
	sourceTextArea
		askBeforeDiscardingEdits: true;
		vResizing: #spaceFill;
		hResizing: #spaceFill.

	sourceTextArea spaceFillWeight: 3.
	sourceTextArea warningLimit: self warningLimit.
	sourceTextAreaLimit := sourceTextArea warningLimit.
	sourceTextArea warningLimit: -1.

	^ sourceTextArea! !

!AbstractNautilusUIWithoutPackages methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
buildCommentButton

	^ (PluggableButtonMorph
			on: self 
			getState: #commentButtonState
			action: #commentButtonAction
			label: #commentButtonLabel) hResizing: #spaceFill; vResizing: #shrinkWrap! !

!AbstractNautilusUIWithoutPackages methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
buildCommentPane

	commentTextArea := PluggableTextMorph
							on: self
							text: #getComments
							accept: #addComment:notifying:
							readSelection: nil
							menu: #codePaneMenu:shifted:.
				
	commentTextArea color: Color white.
	commentTextArea
		askBeforeDiscardingEdits: true;
		vResizing: #spaceFill;
		hResizing: #spaceFill.
		
	commentTextArea spaceFillWeight: 1.

	^ commentTextArea! !

!AbstractNautilusUIWithoutPackages methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
buildFirstColumn: aWindow

	"^ (aWindow newColumn: {
		self buildLabelMorph.
		self buildList.
		aWindow newRow: {self buildToogleButton. self buildGroupsButton}}) 
		hResizing: #spaceFill; vResizing: #spaceFill"
		
	^ firstColumn := GroupboxMorph new
			addContentMorph: self buildList;
			addContentMorph: (aWindow newRow: {self buildToogleButton. self buildGroupsButton});
			label: self labelText;
			hResizing: #spaceFill;
			vResizing: #spaceFill
			! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
buildGetterFor: aString

	^ aString,'

		^ ', aString! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
buildGroupHierarchyFor: aGroup

	| result coll1 |
	result := OrderedCollection new.
	self browsedEnvironment isSystem
		ifTrue: [ coll1 := aGroup elements ]
		ifFalse:[ coll1 := aGroup elements intersection: self model classes ].
	
	aGroup ifNil: [^ result ].
	((self rootsOfGroup: aGroup) asArray) do:[:class |
		result add: (class -> 0).
		self addSubclassesOf: class in: result withIndex: 1 fromRestrictedCollection: coll1 ].
	^ result! !

!AbstractNautilusUIWithoutPackages methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
buildGroupsButton

	^ (PluggableButtonMorph
			on: self 
			getState: #groupsButtonState
			action: #groupsButtonAction
			label: #groupsButtonLabel) hResizing: #spaceFill; vResizing: #shrinkWrap! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
buildHierarchyFor: aClass

	| result tmp index |
	
	aClass ifNil: [^ {}].
	result := OrderedCollection new.
	tmp := aClass withAllSuperclasses reverse.
	1 to: tmp size do: [:i | result add: (tmp at: i) -> (i-1)].

	index := (tmp size -1).
	self addSubclassesOf: aClass in: result withIndex: index + 1.
	^ result! !

!AbstractNautilusUIWithoutPackages methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
buildInstanceButton

	^ (PluggableButtonMorph
			on: self 
			getState: #instanceButtonState
			action: #instanceButtonAction
			label: #instanceButtonLabel) hResizing: #spaceFill; vResizing: #shrinkWrap! !

!AbstractNautilusUIWithoutPackages methodsFor: 'plugins display' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
buildLeftPlugins

	| left |
	left := self model plugins select: [:each | each position = #left ].! !

!AbstractNautilusUIWithoutPackages methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
buildList

	list := PluggableIconListMorph
			on: self 
			list: #getList 
			primarySelection: #selected
			changePrimarySelection: #selected:
			listSelection: #listSelectionAt:
			changeListSelection: #listSelectionAt:put:
			menu: #menu:shifted:.
		
	list getIconSelector: #listIcon:.		
	list resetListSelector: #resetListSelection.
	list autoDeselect: true.
	list doubleClickSelector: #doubleClick.
	list wrapSelector: #listWrapper:.
	list hResizing: #spaceFill.
	list vResizing: #spaceFill.
	^ list! !

!AbstractNautilusUIWithoutPackages methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
buildList2

	list2 := PluggableIconListMorph
				on: self
				list: #getList2
				primarySelection: #selected2
				changePrimarySelection: #selected2:
				listSelection: #listSelection2At:
				changeListSelection: #listSelection2At:put:
				menu: #menu2:shifted:.
							
	list2 keystrokeActionSelector: #arrowKey2:from:.
	list2 getIconSelector: #listIcon2:.
	list2 resetListSelector: #resetListSelection2.
	list2 autoDeselect: true.
	list2 doubleClickSelector: #doubleClick2.
	list2 wrapSelector: #listWrapper2:.
	list2 hResizing: #spaceFill.
	list2 vResizing: #spaceFill.
	^ list2! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:52'!
buildPackageHierarchyFor: aPackage

	| result coll1 |

	result := OrderedCollection new.

	coll1 := self classesForPackage: aPackage.
		
	((self rootsOf: aPackage) asArray sort: [:a :b | a name <= b name ] )do:[:class |
		result add: (class -> 0).
		self addSubclassesOf: class in: result withIndex: 1 fromRestrictedCollection: coll1].
	
	^ result! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 8/2/2011 17:03'!
buildRefactoringSubMenu: aBuilder
	<nautilusClassMenuWithoutPackages>

	self selectedClass ifNil: [^self].

	(aBuilder item: #'Inst var refs...')
		action: [self browseInstVarRefs];
		parent: #Analyzing;
		order: 0.

	(aBuilder item: #'Inst var defs...')
		action: [self browseInstVarDefs];
		parent: #Analyzing;
		order: 100.

	(aBuilder item: #'Create inst var accessors')
		action: [self createInstVarAccessors];
		parent: #Analyzing;
		order: 200;
		withSeparatorAfter.

	(aBuilder item: #'Class var refs...')
		action: [self browseClassVarRefs];
		parent: #Analyzing;
		order: 300.
		
	(aBuilder item: #'Class refs... (N)')
		action: [self browseClassRefs];
		parent: #Analyzing;
		order: 400.
		
	(aBuilder item: #'Browse comment versions... (v)')
		action: [ self browseCommentVersionsOf: {self selectedClass} ];
		parent: #Analyzing;
		order: 500;
		withSeparatorAfter.
		
	(self selectedClass inheritsFrom: SharedPool )
		ifTrue: [ 
			(aBuilder item: #'Shared Pool Users')
				action: [ self systemNavigation browseSharedPoolUsersOf: self selectedClass ];
				parent: #Analyzing;
				enabledBlock: [ self enableSingleClassSelection ];
				order: 550].
		
		
	(aBuilder item: #'Unsent methods...')
		action: [self browseUnusedMethods.];
		parent: #Analyzing;
		order: 600.
	
	(aBuilder item: #'Unreferenced inst vars...')
		action: [self showUnreferencedInstVars.];
		parent: #Analyzing;
		order: 700.
		
	(aBuilder item: #'Unreferenced class vars...')
		action: [self showUnreferencedClassVars.];
		parent: #Analyzing;
		order: 800.! !

!AbstractNautilusUIWithoutPackages methodsFor: 'plugins display' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
buildRightPlugins

	| right |
	right := self model plugins select: [:each | each position = #right ].! !

!AbstractNautilusUIWithoutPackages methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
buildSecondColumn: aWindow

	"^ (aWindow newColumn: {
		self buildLabelMorph2.
		self buildList2.
		aWindow newRow: {self buildInstanceButton. self buildCommentButton}}) 
		hResizing: #spaceFill; vResizing: #spaceFill"
		
	^ secondColumn := GroupboxMorph new
			addContentMorph: self buildList2;
			addContentMorph: (aWindow newRow: {self buildInstanceButton. self buildCommentButton});
			label: self labelText2;
			hResizing: #spaceFill;
			vResizing: #spaceFill! !

!AbstractNautilusUIWithoutPackages methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
buildSeparator

	^ ImageMorph new newForm: (self iconClass iconNamed: #separatorIcon)! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
buildSetterFor: aString

	^ aString, ': anObject
	
		', aString, ' := anObject'! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
buildSwitchToByteCodeButton

	^ ToogleIconicButton new
			model: self;
			actionSelector: #switchToByteCodeButton;
			color: Color transparent;
			extent: 24@24;
			borderWidth: 0;
			statusSelector: #showByteCode;
			enabledIcon: (NautilusIcons iconNamed: #byteCodeSelectedIcon);
			disabledIcon: (NautilusIcons iconNamed: #byteCodeUnselectedIcon);
			helpText: 'Show byteCode'.! !

!AbstractNautilusUIWithoutPackages methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
buildSwitchToDecompileButton

	^ ToogleIconicButton new
			model: self;
			actionSelector: #switchToDecompileButton;
			color: Color transparent;
			extent: 24@24;
			borderWidth: 0;
			statusSelector: #showDecompile;
			enabledIcon: (NautilusIcons iconNamed: #decompileSelectedIcon);
			disabledIcon: (NautilusIcons iconNamed: #decompileUnselectedIcon);
			helpText: 'Show decompiled method'.! !

!AbstractNautilusUIWithoutPackages methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
buildSwitchToSourceCodeButton

	^ ToogleIconicButton new
			model: self;
			actionSelector: #switchToSourceCodeButton;
			color: Color transparent;
			extent: 24@24;
			borderWidth: 0;
			statusSelector: #showSource;
			enabledIcon: (NautilusIcons iconNamed: #sourceSelectedIcon);
			disabledIcon: (NautilusIcons iconNamed: #sourceUnselectedIcon);
			helpText: 'Show source code'.! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 15:02'!
buildTabbedNameOf: anElement
			
	| tab result assoc |
	
	tab := '   '.
	result := ''.
	assoc := cachedHierarchy detect: [:each | each key == anElement ] ifNone: [''->0].
	1 to: assoc value do: [:i | result := tab, result].
	^ result, anElement asString! !

!AbstractNautilusUIWithoutPackages methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
buildTextAreaButtonsColumn: aWindow

	| column |
	column := PanelMorph new.
	column 
		changeTableLayout;
		listDirection: #topToBottom.
		
		{	self buildSwitchToSourceCodeButton.
			self buildSwitchToByteCodeButton.
			self buildSwitchToDecompileButton.
			self buildSeparator.
			self buildBrowseInstVarsButton.
			self buildBrowseClassVarsButton.
			self buildSeparator} reverse do: [:each | column addMorph: each ].
	
	column 
		vResizing: #spaceFill;
		width: 24;
		hResizing: #rigid.
	
	^ column! !

!AbstractNautilusUIWithoutPackages methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
buildToogleButton

	^ (PluggableButtonMorph
			on: self 
			getState: #toogleButtonState
			action: #toogleButtonAction
			label: #toogleButtonLabel) hResizing: #spaceFill; vResizing: #shrinkWrap! !

!AbstractNautilusUIWithoutPackages methodsFor: 'plugins display' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
buildTopPlugins
	^ self subclassResponsibility! !

!AbstractNautilusUIWithoutPackages methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
buildUpAndDownArrowIcon: aMethod

	| container up down |
	
	container := Morph new.
	container 
		extent: 12@12;
		color: Color transparent.
		
	up := IconicButton new 
				target: self;
				actionSelector: #arrowUp:;
				arguments: { aMethod };
				labelGraphic: (self iconClass iconNamed: #arrowDoubleUp);
				color: Color transparent;
				extent: 12 @ 6;
				helpText: 'Browse overriden message';
				borderWidth: 0.
				
	down :=  IconicButton new 
				target: self;
				actionSelector: #arrowDown:;
				arguments: { aMethod };
				labelGraphic: (self iconClass iconNamed: #arrowDoubleDown);
				color: Color transparent;
				extent: 12 @ 6;
				helpText: 'Browse overriding messages';
				borderWidth: 0.
				
	^ container
		changeTableLayout;
		listDirection: #topToBottom;
		addMorph: down;
		addMorph: up;
		yourself! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
byteCodeSymbol

	^ #ByteCode! !

!AbstractNautilusUIWithoutPackages methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
categoriesLabel

	^ self showInstance
		ifTrue: ['Instance protocols:']
		ifFalse: ['Class protocols:']! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
categoriesMenu: aBuilder
	^ self subclassResponsibility! !

!AbstractNautilusUIWithoutPackages methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
categoriesMenu: aMenu shifted: b

	^ aMenu becomeForward: (self categoryMenuBuilder menu)! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 8/2/2011 17:03'!
categoriesMenuCollector: aBuilder
	<nautilusProtocolMenuWithoutPackages>
	
	self categoriesMenu: aBuilder! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus extensions' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
categoriesRefactoringMenu: aMenu shifted: b! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
categorizeAllUncategorizedMethods
	"Categorize methods by looking in parent classes for a method category."

	self categorizeAllUncategorizedMethodsOf: self selectedClass.

	" no need to update, announcements do the job "! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
categorizeMethod
	^ self subclassResponsibility! !

!AbstractNautilusUIWithoutPackages methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
categoryIconFor: aCategory

	^ nil! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
categoryMenuBuilder

	^ NautilusPragmaMenuBuilder withAllPragmaKeywords: {self commonPragma. self categoryPragma} model: self! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 8/2/2011 17:03'!
categoryPragma

	^'nautilusProtocolMenuWithoutPackages'! !

!AbstractNautilusUIWithoutPackages methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
categoryWrapper: anItem

	^ anItem! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
changedLabels

	firstColumn label: self labelText.
	secondColumn label: self labelText2.! !

!AbstractNautilusUIWithoutPackages methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
classAdded: anAnnouncement
	
	| class |
	window ifNil: [^ self ].
	window isDisplayed ifFalse: [ ^ self ].
	
	class := anAnnouncement item.
	self updateClassView.
	self removeFromPackagesIconsCache: class package! !

!AbstractNautilusUIWithoutPackages methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
classCommented: anAnnouncement
	" announcement handled when a class has been commented " 

	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [ ^ self ].
	((self selectedClass = anAnnouncement item) and: [ self showComment ])
		ifTrue: [ self changed: #getComments ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 8/2/2011 17:03'!
classFixPragma

	^'nautilusClassFixMenuWithoutPackages'! !

!AbstractNautilusUIWithoutPackages methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
classIconFor: aClass

	ClassesIconsCache 
		at: aClass 
		ifPresent: [:icon | ^ icon copy ].

	^ ClassesIconsCache at: aClass put: (self iconClass iconNamed: #blank)! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
classLabel

	^'Class'! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
classMenuBuilder

	^NautilusPragmaMenuBuilder withAllPragmaKeywords: {self classFixPragma. self classPragma} model: self! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 8/2/2011 17:03'!
classPragma

	^'nautilusClassMenuWithoutPackages'! !

!AbstractNautilusUIWithoutPackages methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
classRecategorized: anAnnouncement
	
	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [ ^ self ].
	self selectedClass = anAnnouncement item
		ifTrue: [ self update ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 7/20/2011 14:58'!
classRemoved: anAnnouncement
	
	| class oldPackage |
	class := anAnnouncement item.
	window isDisplayed ifFalse: [ ^ self ].
	(self
		ifPackages: [ self getRawList2 includes: class ]
		ifClasses: [ self getRawList includes: class ])
			ifTrue: [
				self selectedClass = class
					ifTrue: [ self selectedClass: nil ].
				window isDisplayed ifFalse: [ ^ self ].
				self halt.
				oldPackage := RPackageOrganizer default packageNamed: (anAnnouncement event environmentAt: #category).
	self removeFromPackagesIconsCache: oldPackage.
				self updateBothView ].
	! !

!AbstractNautilusUIWithoutPackages methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
classRenamed: anAnnouncement
	
	| class |
	class := anAnnouncement item.
	window ifNil: [ ^ self].
	window isDisplayed ifFalse: [ ^ self ].
	(self
		ifPackages: [ self getRawList2 includes: class ]
		ifClasses: [ self getRawList2 includes: class ])
			ifTrue: [ self updateClassView ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
classReorganized: anAnnouncement
	
	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [ ^ self ].
	
	anAnnouncement item = self selectedClass
		ifTrue: [	self update ].! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 8/2/2011 17:03'!
classesFixMenu: aBuilder
	<nautilusClassFixMenuWithoutPackages>
	
	(aBuilder item: #'Find Method... (f)')
		action: [self findMethod];
		order: 0;
		help: 'Search for a method by selector'.
		
	(aBuilder item: #'Find Class... (F)')
		action: [ self findClass ];
		order: 100;
		help: 'Search for a method by selector';
		withSeparatorAfter.
	
	(aBuilder item: #'Add class... (n)')
		action: [ self addClass ];
		order: 200;
		help: 'Create a new class'.
	(aBuilder item: #'Add trait...')
		action: [ self addTrait ];
		order: 300;
		withSeparatorAfter.
		
	(aBuilder item: #'Browse full (b)')
		action: [self fullBrowse];
		order: 999;
		help: 'Open the same browser'.! !

!AbstractNautilusUIWithoutPackages methodsFor: 'plugins announcements' stamp: 'BenjaminVanRyseghem 7/20/2011 14:49'!
classesForPackage: aPackage

	" In fact aPackage is a String "
	
	^ ((self browsedEnvironment forCategories: { aPackage }) classes select: [:each | each isMeta not]) asOrderedCollection sort: [:a :b | a name <= b name]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 8/2/2011 17:03'!
classesMenu: aBuilder
	<nautilusClassMenuWithoutPackages>

	self selectedClass ifNil: [^self].
		
	(aBuilder item: #'Browse restricted (B)')
		action: [self restrictedBrowseClass];
		order: 1000;
		help: 'Open a browser on a restricted view';
		withSeparatorAfter.
		
	(aBuilder item: #Analyzing)
		enabledBlock: [ self selectedClasses size <= 1 ];
		order: 1100.
	
	(aBuilder item: #'Move to package...')
		action: [ self moveInNewPackage ];
		order: 1200.	

	(aBuilder item: #'Rename... (r)')
		action: [ self renameClass ];
		enabledBlock: [ self selectedClasses size <= 1 and: [ self showInstance ]];
		order: 1300.	
			
	(aBuilder item: #'Copy... (c)')
		action: [ self copyClass ];
		order: 1400.	
			
	(aBuilder item: #'Remove... (x)')
		action: [ self removeClasses ];
		icon: (self iconClass iconNamed: #removeIcon);
		order: 1500;
		withSeparatorAfter.
			
	(aBuilder item: #'File Out')
		action: [ self fileOutClass ];
		withSeparatorAfter;
		order: 1600.	
			
	self showGroups
		ifTrue: [
			self selectedGroup isReadOnly 
				ifFalse: [
					(aBuilder item: #'Remove from Group (X)')
						action: [ self removeClassFromGroup ];
						order: 1700]]
		ifFalse: [
			(aBuilder item: #'Add in Group... (e)')
						action: [ self addClassInGroup ];
						order: 1700]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
classesMenu: aMenu shifted: aBoolean 

	^ aMenu becomeForward: (self classMenuBuilder menu)! !

!AbstractNautilusUIWithoutPackages methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
clearUserEditFlag
	
	self changed: #clearUserEdits! !

!AbstractNautilusUIWithoutPackages methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
codePaneMenu: aMenu shifted: shifted 
	"Note that unless we override perform:orSendTo:, 
	PluggableTextController will respond to all menu items in a 
	text pane"
	| donorMenu |
	donorMenu := shifted
				ifTrue: [SmalltalkEditor shiftedYellowButtonMenu]
				ifFalse: [SmalltalkEditor yellowButtonMenu].
	^ aMenu addAllFrom: donorMenu! !

!AbstractNautilusUIWithoutPackages methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
commentButtonAction

	self toogleShowComment.! !

!AbstractNautilusUIWithoutPackages methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
commentButtonLabel

	^ self commentLabel! !

!AbstractNautilusUIWithoutPackages methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
commentButtonState

	^ self showComment! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
commentLabel

	^ 'Comments'! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 8/2/2011 17:03'!
commonMenu: aBuilder
	<nautilusCommonMenuWithoutPackages>
.
	(aBuilder item: #'Find Method... (f)')
		action: [ self findMethod ];
		order: 0;
		help: 'Search for a method by name';
		withSeparatorAfter.
		
	(aBuilder item: #'Add protocol...')
		action: [ self addCategory ];
		order: 100;
		withSeparatorAfter.
	
	(aBuilder item: #'Browse full (b)')
		action: [ self fullBrowse ];
		order: 200;
		withSeparatorAfter.
		
	(aBuilder item: #'Categorize all uncategorized')
		action: [ self categorizeAllUncategorizedMethods ];
		order: 999;
		withSeparatorAfter.! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 8/2/2011 17:03'!
commonPragma

	^'nautilusCommonMenuWithoutPackages'! !

!AbstractNautilusUIWithoutPackages methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
compileAClassFrom: aString

	sourceTextArea update: #clearUserEdits.
	(self compileANewClassFrom: aString)
		ifNil: [^self]
		ifNotNil: [:class | 
			
			self selectedPackage: class package.
			self selectedClass: class.
			self showHierarchy
						ifTrue: [	self hierarchyClass: class ].
			self showGroups
				ifTrue: [ self updateClassView ]
				ifFalse: [ self updateBothView ]]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
compileAMethodFromCategory: aCategory withSource: aString notifying: aController
	^ self subclassResponsibility! !

!AbstractNautilusUIWithoutPackages methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
compileSource: aText notifying: aController
	^ self subclassResponsibility! !

!AbstractNautilusUIWithoutPackages methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
contentsSelection

	self selectedClass isNil
		ifFalse:[	
			self selectedMethod isNil
				ifTrue: [
					self selectedCategory notNil
						ifTrue: [^ (1 to: self defaultMethodSource size) ]]].
	^ (1 to: 0)! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
copyClass
	
	| association |
	self okToChange ifFalse: [^ self].
	association := self copyClasses: self selectedClasses.
	association key
		ifTrue: [
			self selectedClass: association value.
			self updateClassView]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
createInstVarAccessors
	"Create getters and setters for all inst vars defined at the level of the current class selection, except do NOT clobber or override any selectors already understood by the instances of the selected class"

	self createInstVarAccessorsOf: self selectedClass! !

!AbstractNautilusUIWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
currentDisplayChoice

	^ currentDisplayChoice ifNil: [ currentDisplayChoice := self sourceCodeSymbol ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
currentDisplayChoice: aSymbol

	currentDisplayChoice := aSymbol.
	
	self changed: #showSource.
	self changed: #showByteCode.
	self changed: #showDecompile.
	self changed: #sourceCode.! !

!AbstractNautilusUIWithoutPackages methodsFor: 'remove me' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
debug

	self halt.! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
decompileSymbol

	^ #Decompile! !

!AbstractNautilusUIWithoutPackages methodsFor: 'annotation pane' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
defaultAnnotationInfo
	"see annotationRequests comment"
	^ #(timeStamp messageCategory sendersCount implementorsCount allChangeSets)! !

!AbstractNautilusUIWithoutPackages methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
defaultClassDescriptor

	| string |
	string := 'Object subclass: #NameOfSubclass
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: '''.
	^ self selectedPackage
		ifNil: [string, '''' ]
		ifNotNil: [:package | string, package name, '''' ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
defaultMethodSource


	^ 'message selector and argument names
	"comment stating purpose of message"

	| temporary variable names |
	statements'! !

!AbstractNautilusUIWithoutPackages methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
doItContext

	^ nil! !

!AbstractNautilusUIWithoutPackages methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
doItReceiver

	^ self selectedClass theNonMetaClass! !

!AbstractNautilusUIWithoutPackages methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
doubleClick

	self 
		ifGroups: [ self doubleClickOnGroup ]
		ifNot: [
			self ifPackages: [ self doubleClickOnPackage ] ifClasses: [ self doubleClickOnClass ]]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
doubleClick2

	self 
		ifPackages: [ self doubleClickOnClass ] 
		ifClasses: [ self doubleClickOnPackage ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
doubleClickOnClass

	self selectedClass
		ifNil: [ ^ self ]
		ifNotNil: [:class |
			self showGroups
				ifTrue: [ self model class openOnClass: class onGroup: self selectedGroup ]
				ifFalse: [ self model class openOnClass: class ]]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
doubleClickOnGroup

	self selectedGroup 
		ifNil: [ ^self ]
		ifNotNil:[:group | self model class openOnGroup: group ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
doubleClickOnPackage

	self selectedPackage
		ifNil: [ ^ self ]
		ifNotNil:[:package | self model class openOnPackage: package ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
elementsMenu: aBuilder
	^ self subclassResponsibility! !

!AbstractNautilusUIWithoutPackages methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
elementsMenu: aMenu shifted: b

	^ aMenu becomeForward: (self methodMenuBuilder menu)! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 8/2/2011 17:03'!
elementsMenuCollector: aBuilder
	<nautilusMethodMenuWithoutPackages>	
	self elementsMenu: aBuilder! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus extensions' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
elementsRefactoringMenu: aMenu shifted: b! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
enableMultipleMenuItems

	^ self selectedItems size > 1! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
enableSingleClassSelection

	^ self selectedClasses size <= 1! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
enableSingleMenuItems

	^ self selectedItems size <= 1! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
fileOutClass
	"Print a description of the selected class onto a file whose name is the 
	category name followed by .st."

	self fileOutClasses: self selectedClasses! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
fileOutMethods
	^ self subclassResponsibility! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
fileOutPackage

	self fileOutPackages: self selectedPackages! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
findClass
	"Search for a class from a pattern or from the recent list"
	| pattern recentList |
	self okToChange ifFalse: [^ self flashPackage ].
	recentList := self model recentClasses elements intersection: self model classes.
	recentList size == 0
		ifTrue: [pattern := UIManager default request: 'Class name or fragment?']
		ifFalse: [pattern := UIManager default 
				enterOrRequestFrom: recentList 
				lines: #() 
				title: 'Class name or fragment?'].
	pattern isBehavior
		ifTrue: [
			self showInstance: pattern isMeta not.
			self selectedPackage: pattern package.
			self selectedClass: pattern]
		ifFalse:[
			pattern isEmptyOrNil ifTrue: [^ self flashPackage ].
			pattern := self systemNavigation classFromPattern: pattern withCaption: ''.
			pattern ifNil: [^ self flashPackage]].
	self showGroups: false.
	self selectedPackage: pattern package.
	self selectedClass: pattern.
	self updateBothView! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
findMethod
	"Search for a method in the lookup of the selected class"

	| foundMethod class |
	self okToChange ifFalse: [^ self flashPackage ].

	foundMethod := self findMethodIn: self selectedClass.
	foundMethod ifNil: [^ self ].
	class := foundMethod methodClass.
	self showGroupsSilently: false.
 	self model package: class package class: class category: foundMethod protocol method: foundMethod.
	self showPackages ifFalse: [
		classesSelection removeAll.
		classesSelection at: class put: true ].
	self updateBothView.
	self update.
	self changed: #sourceCode! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
findPackage

	"Search for a package from a pattern or from the recent list"
	| foundPackage packagesList |
	self okToChange ifFalse: [^ self ].
	packagesList := (self model recentClasses elements collect: [:each | each package name]) asSet asArray sort.

	foundPackage := self findPackageIn: packagesList.

	self selectedPackage = foundPackage ifTrue: [ ^ self ].
	
	self selectedPackage: foundPackage.
	self selectedClass: nil.
	self updatePackageView.
! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
flashPackage

	"self 
		ifPackages: [ list flash ]
		ifClasses: [ list2 flash ]"! !

!AbstractNautilusUIWithoutPackages methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
forceSelectedMethod: aMethod 
	^ self subclassResponsibility! !

!AbstractNautilusUIWithoutPackages methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
forceSelection: anObject! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
foundPackageOf: aClass

	aClass ifNil: [^ nil].
	^ aClass package! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
fullBrowse
	^ self subclassResponsibility! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
getClassHierarchy

	self hierarchyClass
		ifNil: [^self getClassesList].

	^ cachedHierarchy collect: [:each | each key ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
getClassHierarchy2

	^ self selectedPackage
		ifNil: [{}]
		ifNotNil:[:package |
			cachedHierarchy := self buildPackageHierarchyFor: package.
			cachedHierarchy collect: [:each | each key ]]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
getClassesList

	^ self model classes! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
getClassesList2

	^ self model packagesUsedByTheSelectedClass! !

!AbstractNautilusUIWithoutPackages methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
getComments

	^ self selectedClass
		ifNil: [
			self selectedPackage
				ifNil: [ '' ]
				ifNotNil: [:package | '' "package comment" ]]
		ifNotNil: [:class | class comment ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
getGroupHierarchy

	^ self selectedGroup 
		ifNil: [^ {}]
		ifNotNil: [:group |
			cachedHierarchy := self buildGroupHierarchyFor: group.
			cachedHierarchy collect: [:assoc | assoc key] ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/2/2011 16:47'!
getGroupsKeyList

	^ self groupsManager groups! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
getGroupsValuesList

	^ self selectedGroup 
		ifNil: [{}]
		ifNotNil: [:group | group elements ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
getList
	
	^ self 
		ifGroups: [ self getGroupsKeyList ]
		ifNot: [
			self 
				ifPackages: [ self getPackagesList ] 
				ifClasses: [
					cachedHierarchy
						ifNil: [ self getClassHierarchy ]
						ifNotNil: [:col | col collect: [:assoc | assoc key]]]]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
getList2

	^ self 
		ifGroups: [
			self showHierarchy
				ifTrue: [ self getGroupHierarchy ]
				ifFalse: [ self getGroupsValuesList ]]
		ifNot: [
			 self 
				ifPackages: [
					self showHierarchy
						ifTrue: [ self getClassHierarchy2 ]
						ifFalse: [ self getPackagesList2 ]]
				ifClasses: [self getClassesList2 ]]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
getPackagesList

	^ self model packages reverse sort: [:a :b | a name first = $_ ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
getPackagesList2

	^ self model classesInTheSelectedPackage! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
getRawList
	
	^ self 
		ifGroups: [ self getGroupsKeyList ]
		ifNot: [
			self 
				ifPackages: [ self getPackagesList ] 
				ifClasses: [
					cachedHierarchy
						ifNil: [ self getClassHierarchy ]
						ifNotNil: [:col | col collect: [:assoc | assoc key]]]]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
getRawList2

	self showPackages
		ifTrue: [
			cachedHierarchy
				ifNotNil:[:col | ^col collect: [:each | each key]]]
		ifFalse: [
			^ self 
				ifGroups: [ self getGroupsValuesList ]
				ifNot: [
					 self 
						ifPackages: [self getPackagesList2 ]
						ifClasses: [self getClassesList2 ]]]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 8/2/2011 17:03'!
groupFixPragma

	^'nautilusGroupFixMenuWithoutPackages'! !

!AbstractNautilusUIWithoutPackages methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
groupIconFor: aGroup

	GroupsIconsCache 
		at: aGroup 
		ifPresent: [:icon | ^ icon copy ].
	
	^ GroupsIconsCache
		at: aGroup
		put: (IconicButton new 
				target: self;
				actionSelector: #restrictedBrowseGroup:;
				arguments: {{aGroup}};
				labelGraphic: (self iconClass iconNamed: #groupIcon);
				color: Color transparent;
				extent: 15 @ 16;
				borderWidth: 0)! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
groupMenuBuilder

	^NautilusPragmaMenuBuilder withAllPragmaKeywords: {self groupFixPragma. self groupPragma} model: self! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 8/2/2011 17:03'!
groupPragma

	^'nautilusGroupMenuWithoutPackages'! !

!AbstractNautilusUIWithoutPackages methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/2/2011 16:28'!
groupsButtonAction

	self toogleShowGroups! !

!AbstractNautilusUIWithoutPackages methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
groupsButtonLabel

	^ 
		self showGroups
			ifTrue: [ self packageLabel ]
			ifFalse: [ self groupsLabel ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
groupsButtonState

	^ false! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 8/2/2011 17:04'!
groupsFixMenu: aBuilder
	<nautilusGroupFixMenuWithoutPackages>

	(aBuilder item: #'Find Class... (f)')
		action: [self findClass];
		order: 0;
		help: 'Search for a class by name';
		withSeparatorAfter.
	
	(aBuilder item: #'Browse full (b)')
		action: [self fullBrowse];
		order: 999.! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
groupsLabel

	^ 'Groups'! !

!AbstractNautilusUIWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
groupsManager

	^ self model groupsManager! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 8/2/2011 17:04'!
groupsMenu: aBuilder
	<nautilusGroupMenuWithoutPackages>

	self selectedGroup ifNil: [ ^ self ].
		
	(aBuilder item: #'Browse restricted (B)')
		action: [ self restrictedBrowseGroup: self selectedGroups ];
		order: 1000;
		withSeparatorAfter.
		
	(aBuilder item: #'Merge groups')
		action: [self mergeGroups];
		enabledBlock: [ self selectedGroups size > 1];
		order: 1100.

	self selectedGroup isNil
		ifFalse: [
			self selectedGroup isReadOnly
				ifFalse: [
					(aBuilder item: #'Rename... (r)')
						action: [self renameGroup];
						enabledBlock: [ self selectedGroups size <= 1];
						order: 1200 ].
			self selectedGroup removable
				ifTrue: [
					(aBuilder item: #'Remove groups (x)')
						icon: (self iconClass iconNamed: #removeIcon);
						action: [self removeGroup];
						order: 1200 ]]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
groupsMenu: aMenu shifted: aBoolean 
	" Morphic's menus are filled up when pragma's one are returned from a method, so I have to substitute the morphic menu by the pragma one "
	
	^ aMenu becomeForward: (self groupMenuBuilder menu)! !

!AbstractNautilusUIWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
hierarchyClass

	^ hierarchyClass! !

!AbstractNautilusUIWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
hierarchyClass: aClass

	hierarchyClass := aClass.
	cachedHierarchy := self buildHierarchyFor: aClass.! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
historyChanged

	self setWindowTitle.
	self changed: #nextButtonEnablementState.
	self changed: #previousButtonEnablementState! !

!AbstractNautilusUIWithoutPackages methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
iconClass

	^ NautilusIcons! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
ifGroups: aBlock ifNot: anotherBlock

	^self showGroups
			ifTrue: aBlock
			ifFalse: anotherBlock! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
ifPackages: pBlock ifClasses: cBlock

	^ self showPackages
		ifTrue: pBlock
		ifFalse: cBlock! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
initialize

	super initialize.
	cachedHierarchy := OrderedCollection new.
	groupsSelection := Dictionary new.
	packagesSelection := Dictionary new.
	classesSelection := Dictionary new.
	
	self registerToAnnouncements! !

!AbstractNautilusUIWithoutPackages methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
instanceButtonAction

	self toogleShowInstance! !

!AbstractNautilusUIWithoutPackages methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
instanceButtonLabel

	^ self showInstance
		ifTrue: [ self classLabel ]
		ifFalse: [ self instanceLabel ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
instanceButtonState

	^ false! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
instanceLabel

	^'Instance'! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
isAClassSelected

	^ self selectedClass notNil! !

!AbstractNautilusUIWithoutPackages methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
keyPressedOnCategory: anEvent
	^ self subclassResponsibility! !

!AbstractNautilusUIWithoutPackages methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
keyPressedOnElement: anEvent
	^ self subclassResponsibility! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
labelText

	^ self showGroups
		ifTrue: [ 'Groups:']
		ifFalse: [self ifPackages: ['Packages:'] ifClasses: ['Classes:']]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
labelText2

	^ self ifPackages: ['Classes:'] ifClasses: ['Packages:']! !

!AbstractNautilusUIWithoutPackages methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
listIcon2: anItem

	^ self 
		ifPackages: [ self classIconFor: anItem ]
		ifClasses: [ self packageIconFor: anItem ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
listIcon: anItem
	" I return the icon corresponding to anItem in the leftmost list "


	^ self showGroups
		ifTrue: [ self groupIconFor: anItem ]
		ifFalse: [
			" if I do not show groups, I have to know if I show packages or classes "
			self 
				ifPackages: [ self packageIconFor: anItem ]
				ifClasses: [ self classIconFor: anItem ]]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'list selections' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
listSelection

	^ self showGroups
		ifTrue: [ groupsSelection ]
		ifFalse: [
			self
				ifPackages: [ packagesSelection ]
				ifClasses: [ classesSelection  ]]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'list selections' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
listSelection2

	^ self
		ifPackages: [ classesSelection ]
		ifClasses: [ packagesSelection ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'list selections' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
listSelection2At: anIndex

	| elt |
	elt := self getRawList2 at: anIndex ifAbsent: [ ^false ].
	^ self listSelection2 at: elt ifAbsent: [ false ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'list selections' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
listSelection2At: anIndex put: aBoolean

	| elt |
	aBoolean ifNil: [ ^ self ].
	elt := self getRawList2 at: anIndex.
	self listSelection2 at: elt put: aBoolean.
	self changed: #hasSelectedSelections! !

!AbstractNautilusUIWithoutPackages methodsFor: 'list selections' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
listSelectionAt: anIndex

	| elt |
	elt := self getRawList at: anIndex ifAbsent: [ ^ false ].
	^ self listSelection at: elt ifAbsent: [ false ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'list selections' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
listSelectionAt: anIndex put: aBoolean

	| elt |
	elt := self getRawList at: anIndex.
	self listSelection at: elt put: aBoolean.
	self changed: #hasSelectedSelections! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 15:03'!
listWrapper2: anElement

	^ self 
		ifPackages:	[
			"anElement is a Class"
			self showHierarchy
				ifTrue: [ self buildTabbedNameOf: anElement ]
				ifFalse: [
					self selectedPackage 
						ifNil: [ anElement asString ]
						ifNotNil: [ anElement asString ]]]
		ifClasses: [
			"anElement is a RPackage"
			(self selectedClass category == anElement)
				ifTrue: [anElement asString]
				ifFalse: ['*', anElement asString]]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 8/2/2011 16:57'!
listWrapper: anElement

	anElement = 0 ifTrue: [^''].
	^ self 
		ifGroups: [ anElement name ]
		ifNot: [ self 
				ifPackages: [ anElement asString  ] 
				ifClasses: [ self buildTabbedNameOf: anElement ]]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 8/2/2011 17:38'!
mcPackageModified: anAnnouncement
	" handled when a package become dirty "
	
"	| rpackage |
	window ifNil: [^ self ].
	window isDisplayed ifFalse: [ ^ self ].
	
	rpackage := anAnnouncement package correspondingRPackage.
	(self model packages includes: rpackage )
		ifTrue: [ self updatePackageView ]"! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
menu2: aMenu shifted: aBoolean 
	self
		ifPackages: [self classesMenu: aMenu shifted: aBoolean]
		ifClasses: [
			self showGroups
				ifTrue: [self groupsMenu: aMenu shifted: aBoolean]
				ifFalse: [self packagesMenu: aMenu shifted: aBoolean]].
	^ aMenu! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
menu: aMenu shifted: aBoolean 
	self
		ifPackages: [
			self showGroups
				ifTrue: [self groupsMenu: aMenu shifted: aBoolean]
				ifFalse: [self packagesMenu: aMenu shifted: aBoolean]]
		ifClasses: [self classesMenu: aMenu shifted: aBoolean].
	^ aMenu! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
mergeGroups

	| group |
	group := self mergeGroups: self selectedGroups.
	group
		ifNotNil: [ 
			self groupsManager addAGroup: group.
			self selectedGroup: group.
			self updateBothView]
! !

!AbstractNautilusUIWithoutPackages methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
methodAdded: anAnnouncement
	^ self subclassResponsibility! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
methodHierarchy
	"Create and schedule a method browser on the hierarchy of implementors."

	self methodHierarchyFrom: self selectedMethod! !

!AbstractNautilusUIWithoutPackages methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
methodIconFor: aMethod

	| result |
	MethodsIconsCache
		at: aMethod
		ifPresent: [:icon | ^ icon copy ].
	result :=  aMethod containsHalt
			ifTrue: [ self iconClass iconNamed: #breakpoint ]
			ifFalse: [
				aMethod containsFlag
					ifTrue: [ self iconClass iconNamed: #flag ]
					ifFalse: [
						aMethod isTestMethod
							ifTrue: [| icon |
								icon :=  self iconClass iconNamed: #testNotRun.

								aMethod hasPassedTest
									ifTrue: [	icon :=  self iconClass iconNamed: #testGreen ].

								aMethod hasFailedTest
									ifTrue: [	icon :=  self iconClass iconNamed: #testYellow ].

								aMethod hasErrorTest
									ifTrue: [	icon :=  self iconClass iconNamed: #testRed ].
								IconicButton new 
											target: self;
											actionSelector: #runTestForAMethod:;
											arguments: { aMethod };
											labelGraphic: icon ;
											color: Color transparent;
											extent: 12 @ 12;
											borderWidth: 0 ]
							ifFalse: [					
								aMethod correspondingTestMethod
									ifNotNil: [:testMethod || icon |
										icon :=  self iconClass iconNamed: #testNotRun.

										testMethod hasPassedTest
											ifTrue: [	icon :=  self iconClass iconNamed: #testGreen ].

										testMethod hasFailedTest
											ifTrue: [	icon :=  self iconClass iconNamed: #testYellow ].

										testMethod hasErrorTest
											ifTrue: [	icon :=  self iconClass iconNamed: #testRed ].
										IconicButton new 
													target: self;
													actionSelector: #runTestForAMethod:;
													arguments: { aMethod };
													labelGraphic: icon ;
													color: Color transparent;
													extent: 12 @ 12;
													helpText: 'Run tests';
													borderWidth: 0 ]
									ifNil: [ | isOverriden |
										isOverriden := aMethod isOverriden.
										aMethod isOverride
											ifTrue: [ 
												isOverriden
													ifTrue: [ self buildUpAndDownArrowIcon: aMethod ]
													ifFalse:[  IconicButton new 
																	target: self;
																	actionSelector: #arrowUp:;
																	arguments: { aMethod };
																	labelGraphic: (self iconClass iconNamed: #arrowUp);
																	color: Color transparent;
																	helpText: 'Browse overriden message';
																	extent: 12 @ 12;
																	borderWidth: 0 ]]
											ifFalse: [
												isOverriden
													ifTrue: [ IconicButton new 
																	target: self;
																	actionSelector: #arrowDown:;
																	arguments: { aMethod };
																	labelGraphic: (self iconClass iconNamed: #arrowDown);
																	color: Color transparent;
																	helpText: 'Browse overriding messages';
																	extent: 12 @ 12;
																	borderWidth: 0 ]
													ifFalse: [ self iconClass iconNamed: #blank]]]]]].
		^ MethodsIconsCache at: aMethod put: result! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
methodMenuBuilder

	^ NautilusPragmaMenuBuilder withAllPragmaKeywords: {self commonPragma. self methodPragma} model: self! !

!AbstractNautilusUIWithoutPackages methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
methodModified: anAnnouncement 

	window isNil ifTrue: [ ^ self ].
	window isDisplayed ifFalse: [ ^ self ].

	( anAnnouncement itemClass = self selectedClass )
		ifTrue: [
			self selectedMethod = anAnnouncement oldItem
				ifTrue: [ | method |
					method := anAnnouncement item.
					self removeFromMethodsIconsCache: method.
					sourceTextArea hasUnacceptedEdits
						ifTrue: [ | sourceCode |
							sourceCode := sourceTextArea text.
							self forceSelectedMethod: (anAnnouncement item).
							self update.
							sourceTextArea setText: sourceCode.
							sourceTextArea hasEditingConflicts: true.
							sourceTextArea update: #codeChangedElsewhere ]
						ifFalse: [
							self selectedMethod: method.
							self update ]]]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 8/2/2011 17:03'!
methodPragma

	^'nautilusMethodMenuWithoutPackages'! !

!AbstractNautilusUIWithoutPackages methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
methodRecategorized: anAnnouncement
	
	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [ ^ self ].
		
	(anAnnouncement item methodClass = self selectedClass)
		ifTrue: [ self update ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
methodRemoved: anAnnouncement
	^ self subclassResponsibility! !

!AbstractNautilusUIWithoutPackages methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
methodWrapper: anItem

	^ anItem selector! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
methodsForCategory: aCategory
	^ self subclassResponsibility! !

!AbstractNautilusUIWithoutPackages methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
methodsLabel

	^ self showInstance
		ifTrue: ['Instance methods']
		ifFalse: ['Class methods']! !

!AbstractNautilusUIWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
model

	^ model! !

!AbstractNautilusUIWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
model: anObject

	model := anObject.
	model when: #historyChanged send: #historyChanged to: self.! !

!AbstractNautilusUIWithoutPackages methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
move: item from: oldCategory to: newCategory isCopy: isCopy

	isCopy
		ifFalse: [
			item methodClass organization
				classify: item selector
				under: newCategory 
				suppressIfDefault: true.
			self selectedMethod: item ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
moveInNewPackage

	"Present a choice of categories or prompt for a new category name and add it before the current selection, or at the end if no current selection"
	| item |
	self okToChange ifFalse: [^ self].

	item := self moveInNewPackage: self selectedClasses.

	self selectedPackage: item.
	self updateBothView! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
moveMethodToPackage
	^ self subclassResponsibility! !

!AbstractNautilusUIWithoutPackages methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 8/2/2011 17:40'!
newMCVersion: anAnnouncement

"	| rpackage |
	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [ ^ self ].
	
	rpackage := anAnnouncement version package correspondingRPackage.
	rpackage ifNil: [ ^ self ].
	( self model packages includes: rpackage )
		ifTrue: [ 
			self removeFromPackagesIconsCache: rpackage.
			self updatePackageView ]"! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
noMethodsString

	^ ClassOrganizer nullCategory! !

!AbstractNautilusUIWithoutPackages methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
okToChange

	self canDiscardEdits ifTrue: [^ true].
	self changed: #wantToChange.  "Solicit cancel from view"
	^ self canDiscardEdits
! !

!AbstractNautilusUIWithoutPackages methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
open

	window := NautilusWindow new model: self.
	self addAll: window.
	window openInWorld.
	self changed:#sourceCode.
	self setWindowTitle! !

!AbstractNautilusUIWithoutPackages methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
packageChanged: anAnnouncement

	window isDisplayed ifFalse: [ ^ self ].

	self showGroups not
		ifTrue: [ self updatePackageView ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
packageCreated: anAnnouncement

	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [ ^ self ].
	self showGroups not
		ifTrue: [ self updatePackageView ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 8/2/2011 17:03'!
packageFixPragma

	^ 'nautilusPackageFixMenuWithoutPackages'! !

!AbstractNautilusUIWithoutPackages methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 7/20/2011 14:50'!
packageIconFor: aPackage

	PackagesIconsCache 
		at: aPackage
		ifPresent:[:icon | ^ icon copy ].

	(self classesForPackage: aPackage) isEmpty ifTrue: [^ PackagesIconsCache at: aPackage put: (self iconClass iconNamed: #emptyPackageIcon) ].
	
	"aPackage isDirty
		ifTrue: [ ^PackagesIconsCache at: aPackage put: ( IconicButton new 
															target: self;
															actionSelector: #saveDirtyPackages:;
															arguments: {{ aPackage }};
															labelGraphic: (self iconClass iconNamed: #dirtyPackageIcon);
															color: Color transparent;
															extent: 15 @ 16;
															borderWidth: 0) ]."

	^ PackagesIconsCache at: aPackage put: (self iconClass iconNamed: #packageIcon)! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
packageLabel

	^'Packages'! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
packageMenuBuilder

	^ NautilusPragmaMenuBuilder withAllPragmaKeywords: {self packageFixPragma. self packagePragma} model: self! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 8/2/2011 17:03'!
packagePragma

	^ 'nautilusPackageMenuWithoutPackages'! !

!AbstractNautilusUIWithoutPackages methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
packageRenamed: anAnnouncement

	window isDisplayed ifFalse: [ ^ self ].
	self showGroups not
		ifTrue: [ self updatePackageView ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
packageUnregistred: anAnnouncement

	self showGroups not
		ifTrue: [ | package |
			package := anAnnouncement package.
			self selectedPackage = package
				ifTrue: [ self selectedPackage: nil ].
			packagesSelection at: package put: false.
			window isDisplayed ifFalse: [ ^ self ].
			self updatePackageView ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 8/2/2011 17:04'!
packagesFixMenu: aBuilder
	<nautilusPackageFixMenuWithoutPackages>

	(aBuilder item: #'Find Class... (f)')
		action: [self findClass];
		order: 0;
		help: 'Search for a class by name'.
		
	(aBuilder item: #'Find Package... (F)')
		action: [ self findPackage ];
		order: 100;
		help: 'Search for a package by name';
		withSeparatorAfter.
		
	(aBuilder item: #'Add package... (n)')
		action: [self addPackage];
		order: 200;
		help: 'Add a package';
		withSeparatorAfter.
		
	(aBuilder item: #'Browse full (b)')
		action: [self fullBrowse];
		order: 999;
		help: 'Open the same browser'.! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 8/2/2011 17:04'!
packagesMenu: aBuilder
	<nautilusPackageMenuWithoutPackages>

	self selectedPackage ifNil: [ ^ self ].
	
	(aBuilder item: #'Browse restricted (B)')
		action: [self restrictedBrowsePackage];
		order: 1000;
		help: 'Open a browser on a restricted view';
		withSeparatorAfter.
				
	(aBuilder item: #'Rename... (r)')
		action: [self renamePackage];
		order: 1100;
		help: 'Rename a package';
		enabledBlock: [ self selectedPackages size = 1 ].
		
	(aBuilder item: #'Remove... (x)')
		action: [self removePackage];
		order: 1200;
		help: 'Remove a package';
		icon: (self iconClass iconNamed: #removeIcon);
		withSeparatorAfter.
		
	(aBuilder item: #'File Out')
		action: [self fileOutPackage];
		order: 1300;
		help: 'File out a package';
		withSeparatorAfter.
		
	(aBuilder item: #'Add as Group & Browse (g)')
		action: [self addPackageAsGroupAndBrowse];
		order: 1400;
		help: 'Create a group based on the current package and browse it'.
		
	(aBuilder item: #'Add as Group (G)')
		action: [self addPackageAsGroup];
		order: 1500;
		help: 'Create a group based on the current package'.
		
	(aBuilder item: #'Add in Group... (e)')
		action: [self addPackageInGroup];
		order: 1600;
		help: 'Add current package in a group'.! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
packagesMenu: aMenu shifted: aBoolean 

	^ aMenu becomeForward: (self packageMenuBuilder menu)! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
popUpTestsResult: aClass! !

!AbstractNautilusUIWithoutPackages methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
putSourceTextAreaLimit

	sourceTextArea ifNotNil: [ sourceTextArea warningLimit: sourceTextAreaLimit ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'announcement registration' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
registerToAnnouncements

	SystemAnnouncer announcer weak
		on: RPackageCreated send: #packageCreated: to: self;"
		on: RPackageUnregistred send: #packageUnregistred: to: self;"
		on: RPackageRenamed send: #packageRenamed: to: self;
	
		on: SystemClassAddedAnnouncement send: #classAdded: to: self;
		on: SystemClassCommentedAnnouncement send: #classCommented: to: self;
		on: SystemClassRecategorizedAnnouncement send: #classRecategorized: to: self;
		on: SystemClassRemovedAnnouncement send: #classRemoved: to: self;
		on: SystemClassRenamedAnnouncement send: #classRenamed: to: self;
		on: SystemClassReorganizedAnnouncement send: #classReorganized: to: self;
		
		on: SystemMethodAddedAnnouncement send: #methodAdded: to: self;
		on: SystemMethodModifiedAnnouncement send: #methodModified: to: self;
		on: SystemMethodRecategorizedAnnouncement send: #methodRecategorized: to: self;
		on: SystemMethodRemovedAnnouncement send: #methodRemoved: to: self;
		
		on: SystemProtocolAddedAnnouncement send: #classRecategorized: to: self;
		on: SystemProtocolRemovedAnnouncement send: #classRecategorized: to: self.

	TestAnnouncer announcer weak
		on: ATestHasBeenRun send: #testRunned: to: self.
		
	MonticelloAnnouncer announcer weak	
		on: AMCVersionHasBeenCreated send: #newMCVersion: to: self;
		on: AMCPackageHasBeenModified send: #mcPackageModified: to: self.
		
	GroupAnnouncer announcer weak
		on: AGroupHasBeenRegistered send: #aGroupHasBeenRegistered: to: self;
		on: AGroupHasBeenUnregistered send: #aGroupHasBeenUnregistered to: self;
		on: AGroupHasBeenAdded send: #aGroupHasBeenAdded: to: self;
		on: AGroupHasBeenRemoved send: #aGroupHasBeenRemoved: to: self;
		on: AGroupHasBeenRenamed send: #aGroupHasBeenRenamed: to: self! !

!AbstractNautilusUIWithoutPackages methodsFor: 'icon caches' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
removeAllFromMethodsIconsCache: aMethod

	MethodsIconsCache copy keys do: [:method | 
		" for overrides "
		method selector = aMethod selector
			ifTrue: [ MethodsIconsCache removeKey: method ifAbsent: [ ]]].! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
removeClassFromGroup

	self groupsManager remove: self selectedClass from: self selectedGroup.
	self updateClassView.! !

!AbstractNautilusUIWithoutPackages methodsFor: 'icon caches' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
removeClassFromMethodsIconsCache: aClass

	MethodsIconsCache copy keys do: [:method | 
		" for overrides "
		method methodClass = aClass
			ifTrue: [ MethodsIconsCache removeKey: method ifAbsent: [ ]]].! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
removeClasses
	"Remove the selected class from the system, at interactive user request.  Make certain the user really wants to do this, since it is not reversible.  Answer true if removal actually happened."

	| result |
	self okToChange ifFalse: [^ false].
	result := self removeClasses: self selectedClasses.
	result
		ifTrue: [	
		classesSelection removeAll.
		self selectedClass: nil ].
	^ result! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
removeEmptyCategories

	self okToChange ifFalse: [^ self].
	(self methodsForCategory: self selectedCategory) 
		ifEmpty: [ self selectedCategory: nil ].
		
	self removeEmptyCategoriesFrom: self selectedClass.
	
	self update.! !

!AbstractNautilusUIWithoutPackages methodsFor: 'icon caches' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
removeFromClassesIconsCache: aClass
	" not used since the class's icons are always the same "


	ClassesIconsCache removeKey: aClass ifAbsent: [].! !

!AbstractNautilusUIWithoutPackages methodsFor: 'icon caches' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
removeFromGroupsIconsCache: aClass
	" not used since the groups's icons are always the same "


	GroupsIconsCache removeKey: aClass ifAbsent: [].! !

!AbstractNautilusUIWithoutPackages methodsFor: 'icon caches' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
removeFromMethodsIconsCache: aMethod
	" if a test method has changed, we should reset the correspondng method "
	
	| corresponding |
	corresponding := aMethod correspondingMethods.
	corresponding do: [:each | MethodsIconsCache removeKey: each ifAbsent: []].
	MethodsIconsCache removeKey: aMethod ifAbsent: [ ].! !

!AbstractNautilusUIWithoutPackages methodsFor: 'icon caches' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
removeFromPackagesIconsCache: aPackage

	PackagesIconsCache removeKey: aPackage ifAbsent: [].! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
removeGroup

	self okToChange ifFalse: [ ^ self ].
	self selectedGroups
		ifNotEmpty:[:groups |
			groupsSelection removeAll.
			groups do: [:group | self groupsManager removeAGroupSilently: group ].
			self selectedGroup: nil].
		! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
removeMethod: aMethod inClass: aClass
	"If a message is selected, create a Confirmer so the user can verify that  
	the currently selected message should be removed from the system. If 
	so, remove it. "

	self okToChange ifFalse: [^ false].
	^ super removeMethod: aMethod inClass: aClass! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
removeNonLocalSelector: aSymbol

	self selectedClass ifNotNil: [:class | self removeNonLocalSelector: aSymbol from: class ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
removePackage

	| names |
	self selectedPackages 
		ifNotEmpty: [:packages |
			names := packages collect: [:package | package name ].
			names := names joinUsing: String cr.
			(UIManager default confirm: ('Are you sure you want to delete the package(s) named ', String cr, names, ' ?'))
				ifTrue: [
					packages do: [:package |
						self browsedEnvironment packageOrganizer unregisterPackage: package].
					self selectedPackage: nil.
					self updatePackageView]]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
removeSourceTextAreaLimit

	sourceTextArea ifNotNil: [ sourceTextArea warningLimit: -1 ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
renameCategory
	^ self subclassResponsibility! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
renameClass

	self okToChange ifFalse: [ ^ self ].
	self renameClass: self selectedClass.
	self changed: #sourceCode.! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
renameGroup

	| newName |
	self groupsManager renameAGroup: self selectedGroup.
	self updateBothView! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
renamePackage

	self renamePackages: self selectedPackages.
	self updatePackageView.
	! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
resetListSelection

	self listSelection removeAll.! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
resetListSelection2

	self listSelection2 removeAll.! !

!AbstractNautilusUIWithoutPackages methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
resetSelections! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
restrictedBrowseClass

	self selectedClass
		ifNil: [ ^ self ]
		ifNotNil:[:class || newEnvironment |
			newEnvironment := self browsedEnvironment forClasses: {class}.
			 self model class openOnClass: class inEnvironment: newEnvironment ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
restrictedBrowseGroup: aCollection

	aCollection
		ifNotEmpty: [:groups || elements newEnvironment |
			elements := groups gather: [:group | group elements].
			newEnvironment := self browsedEnvironment forClasses: elements.
			self model class openOnGroup: groups first inEnvironment: newEnvironment ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:53'!
rootsOf: aPackage

	| tmp |
	self browsedEnvironment isSystem
		ifTrue: [ tmp := self classesForPackage: aPackage ]
		ifFalse: [ tmp := self model classes intersection: (self classesForPackage: aPackage) ].
		
	^ tmp select: [:each |
		(tmp includes: each superclass)  not]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
rootsOfGroup: aGroup

	| classes |
	self browsedEnvironment isSystem
		ifTrue: [ classes := aGroup elements ]
		ifFalse: [ classes := aGroup elements intersection: self model classes ].
	
	^ classes select: [:each |
		(classes includes: each superclass)  not]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'icons behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
runClassTests

	self selectedClasses
		ifNotEmpty:[:classes | 
			classes do: [:class | self runTestsOfClass: class ]]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'icons behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
runTestFor: aCollection

	aCollection do: [:each | 
		each isTestMethod
			ifTrue: [	self runTestForAMethod: each ]]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'icons behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
runTestForAMethod: aMethod

	| testMethod testClass testResult |
	testMethod := aMethod correspondingTestMethod.
	testMethod ifNil: [ ^ self ].
	testClass := testMethod methodClass.
	testResult := testClass run: testMethod selector.
	
	testResult updateResultsInHistory
	
	"#(failures errors passed) do:[:symbol |
		(testClass history at: symbol) addAll: ( (testResult perform: symbol) collect: [:each | each selector ])]."! !

!AbstractNautilusUIWithoutPackages methodsFor: 'icons behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
runTestsOfClass: aClass 
	
	aClass methodDict do: [:method | 
		method isTestMethod
			ifTrue: [ self runTestForAMethod: method ]].
	self popUpTestsResult: aClass correspondingTestClass ! !

!AbstractNautilusUIWithoutPackages methodsFor: 'icons behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
saveDirtyPackages: aCollection 
	
	
	aCollection isEmptyOrNil ifTrue: [ ^ self ].
	aCollection do: [:package || workCopy browser wrap index |
		
		workCopy := MCWorkingCopy forPackage: (MCPackage named: package name).
		browser :=MCWorkingCopyBrowser new.
		browser
			show;
			workingCopy: workCopy.
		"wrap := MCDependentsWrapper with: workCopy model: browser.
		self halt.
		index := browser workingCopySelectionWrapper: wrap.
		browser workingCopyTreeMorph selectionIndex: index"]
	! !

!AbstractNautilusUIWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
selected

	| item |
	item :=  self 
				ifGroups: [ self selectedGroup ]
				ifNot: [ self ifPackages: [ self selectedPackage ] ifClasses: [ self selectedClass ]].
				
	^self getList indexOf: item.! !

!AbstractNautilusUIWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
selected2

	| item |
	item :=  self 
		ifPackages: [ | tmp |
			tmp := self selectedClass.
			self showInstance ifFalse: [ tmp ifNotNil: [tmp := tmp theNonMetaClass]].
			tmp ] 
		ifClasses: [ self selectedPackage ].
	.
	^self getRawList2 indexOf: item.! !

!AbstractNautilusUIWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
selected2: anInteger

	| selection |
	selection := self getRawList2 at: anInteger ifAbsent: [nil].
	self 
		ifPackages: [ 
			self showInstance ifFalse: [selection ifNotNil: [selection := selection class]].
			self selectedClassWithoutChangingSelection: selection ] 
		ifClasses: [	self selectedPackageWithoutChangingSelection: selection ].
	self changed: #selected2.! !

!AbstractNautilusUIWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
selected: anInteger

	| selection |
	
	selection := self getList at: anInteger ifAbsent: [nil].
	self 
		ifGroups: [ self selectedGroupWithoutChangingSelection: selection ]
		ifNot: [ 
			self 
				ifPackages: [ self selectedPackageWithoutChangingSelection: selection] 
				ifClasses: [ 
					self showInstance ifFalse: [selection ifNotNil: [selection := selection class]].
					self selectedClassWithoutChangingSelection: selection] ].

	self changed: #selected.! !

!AbstractNautilusUIWithoutPackages methodsFor: 'SmalltalkEditor compatibility' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
selectedBehavior

	^ self selectedClass! !

!AbstractNautilusUIWithoutPackages methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
selectedCategory

	^ self model selectedCategory! !

!AbstractNautilusUIWithoutPackages methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
selectedCategory: anObject
	^ self subclassResponsibility! !

!AbstractNautilusUIWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
selectedClass

	| class |
	class := self model selectedClass.
	(self model selectedCategory isNil and: [ self model selectedMethod isNil ])
		ifTrue: [ self setStylerClass: nil ]
		ifFalse: [ self setStylerClass: class ].
	^ class! !

!AbstractNautilusUIWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
selectedClass: aClass 

	self okToChange
		ifTrue: [
			classesSelection removeAll.
			classesSelection at: aClass put: true.
			self selectedClassWithoutChangingSelection: aClass ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
selectedClassComments

	^ self selectedClass
		ifNil: ['']
		ifNotNil: [:class| class comment]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
selectedClassDescription

	^ self selectedClass definition! !

!AbstractNautilusUIWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
selectedClassWithoutChangingSelection: aClass 
	^ self subclassResponsibility! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
selectedClasses

	| associations |
	associations := classesSelection associations select: [:assoc | assoc value ].
	associations := associations collect: [:assoc | assoc key ].
	^ associations select: [:each | each notNil ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
selectedGroup
	
	^ self model selectedGroup! !

!AbstractNautilusUIWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
selectedGroup: anObject

	self okToChange
		ifTrue: [
			groupsSelection removeAll.
			groupsSelection at: anObject put: true.
			self selectedGroupWithoutChangingSelection: anObject ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
selectedGroupWithoutChangingSelection: anObject

	self okToChange
		ifTrue: [
			anObject ifNil: [ groupsSelection removeAll ].
			self model selectedGroup: anObject.
			self selectedClass: nil.
			self updateClassView ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
selectedGroups

	| associations |
	associations := groupsSelection associations select: [:assoc | assoc value ].
	associations := associations collect: [:assoc | assoc key ].
	^ associations select: [:each | each notNil ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
selectedItems

	| associations |
	associations := self listSelection associations select: [:assoc | assoc value ].
	^ associations collect: [:assoc | assoc key ].! !

!AbstractNautilusUIWithoutPackages methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
selectedMethod

	^ self model selectedMethod ! !

!AbstractNautilusUIWithoutPackages methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
selectedMethod: aMethod 
	^ self subclassResponsibility! !

!AbstractNautilusUIWithoutPackages methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
selectedMethodComments

	^ self selectedMethod comment! !

!AbstractNautilusUIWithoutPackages methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
selectedMethodSource

	self selectedMethod
		ifNil: [ ^ '' ]
		ifNotNil: [:method |
			self showSource
				ifTrue: [ 
					self styled: true.
					^ method getSource ].
			self showByteCode
				ifTrue: [ 
					self styled: false.
					^ method symbolic asText].
			self showDecompile
				ifTrue: [ 
					self styled: false.
					^  method decompileWithTemps decompileString asText makeSelectorBoldIn: method methodClass ].
			^ 'error']			! !

!AbstractNautilusUIWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
selectedPackage

	^ self model selectedPackage! !

!AbstractNautilusUIWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
selectedPackage: aPackage
" Force package selection, not used by the lists "
	self okToChange
		ifTrue: [
			packagesSelection removeAll.
			packagesSelection at: aPackage put: true.
			self selectedPackageWithoutChangingSelection: aPackage]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/2/2011 17:38'!
selectedPackageWithoutChangingSelection: aPackage

	self okToChange
		ifTrue: [| class |
			class := self selectedClass.
			(self showPackages and: [class notNil and: [class category ~= aPackage]])
				ifTrue: [ self selectedClass: nil ].
			self model package: aPackage class: self selectedClass category: nil method: nil.

			self updateClassView.
			self update.
			self changed: #getComments.
			self changed: #sourceCode]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
selectedPackages

	| associations |
	associations := packagesSelection associations select: [:assoc | assoc value ].
	associations := associations collect: [:assoc | assoc key ].
	^ associations select: [:each | each notNil ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
setCachedHierarchy: aDict

	cachedHierarchy := aDict.! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
setCachedHierarchyClass: aClass

	cachedHierarchy := self buildHierarchyFor: aClass.! !

!AbstractNautilusUIWithoutPackages methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
setStylerClass: aClass

	sourceTextArea
		ifNotNil: [ sourceTextArea stylerClassOrMetaClass: aClass ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
setWindowTitle

	| title |
	title := self selectedClass 
				ifNil: [ self title ]
				ifNotNil: [:class |
					self selectedMethod
						ifNil: [ class name asString ]
						ifNotNil: [:method |
							method methodClass name asString, '>>#', method selector ]].
	window title: title.! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
showByteCode

	^ self currentDisplayChoice = self byteCodeSymbol! !

!AbstractNautilusUIWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
showComment

	^ self model showComment! !

!AbstractNautilusUIWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
showComment: aBoolean

	self model showComment: aBoolean.
	
	commentTextArea
		ifNil: [ self buildCommentPane ].
		
	aBoolean
		ifTrue: [ sourceCodePanel addMorph: commentTextArea ]
		ifFalse: [ sourceCodePanel removeMorph: commentTextArea ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
showDecompile

	^ self currentDisplayChoice = self decompileSymbol! !

!AbstractNautilusUIWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
showGroups

	^ self model showGroups! !

!AbstractNautilusUIWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/2/2011 16:47'!
showGroups: aBoolean

	self okToChange
		ifTrue: [
			self showPackages 
				ifFalse: [ self showPackagesSilently: true ].
			self selectedGroup
				ifNil: [ self selectedClass: nil ]
				ifNotNil: [:group |
					(group elements includes: self selectedClass)
						ifFalse: [ self selectedClass: nil ].
			aBoolean 
				ifTrue: [ groupsSelection at: group put: true ]
				ifFalse: [ packagesSelection at: self selectedPackage put: true ]].
			self model showGroups: aBoolean.
			self changed: #groupsButtonLabel.
			self changedLabels.
			self updateBothView ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
showGroupsSilently: aBoolean

	self model showGroups: aBoolean! !

!AbstractNautilusUIWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
showHierarchy

	^ self model showHierarchy! !

!AbstractNautilusUIWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
showHierarchy: aBoolean

	self model showHierarchy: aBoolean.
	aBoolean 
		ifTrue: [self hierarchyClass: self selectedClass]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
showInstance

	^ self model showInstance! !

!AbstractNautilusUIWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
showInstance: aBoolean

	self model showInstance: aBoolean.
	classesSelection removeAll.
	self selectedClass 
		ifNotNil: [:class | 
			aBoolean 
				ifTrue: [self selectedClass: class theNonMetaClass]
				ifFalse: [self selectedClass: class class]].
	self update.
	self changed: #instanceButtonLabel! !

!AbstractNautilusUIWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
showPackages

	^ self model showPackages! !

!AbstractNautilusUIWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
showPackages: aBoolean

	self okToChange
		ifTrue: [
			aBoolean
				ifFalse: [| class |
					class := self selectedClass.
					classesSelection at: class put: true.
					self hierarchyClass: class .
					self showGroups
						ifTrue: [self showGroupsSilently: false]].
			self model showPackages: aBoolean.
			self changed: #groupsButtonLabel.
			self updateBothView.
			self changed: #toogleButtonState.
			self changedLabels ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
showPackagesSilently: aBoolean

	self model showPackages: aBoolean.! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
showSource

	^ self currentDisplayChoice = self sourceCodeSymbol! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
showUnreferencedClassVars
	"Search for all class variables known to the selected class, and put up a 
	list of those that have no references anywhere in the system. The 
	search includes superclasses, so that you don't need to navigate your 
	way to the class that defines each class variable in order to determine 
	whether it is unreferenced"
	self showUnreferencedClassVarsOf: self selectedClass.! !

!AbstractNautilusUIWithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
showUnreferencedInstVars
	"Search for all instance variables known to the selected class, and put up a list of those that have no references anywhere in the system.  The search includes superclasses, so that you don't need to navigate your way to the class that defines each inst variable in order to determine whether it is unreferenced"

	self showUnreferencedInstVarsOf: self selectedClass! !

!AbstractNautilusUIWithoutPackages methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
sourceCode

	self styled: true.
	self removeSourceTextAreaLimit.
	^self selectedClass isNil
		ifTrue: [ self defaultClassDescriptor]
		ifFalse:[ self selectedMethod isNil
				ifTrue: [ self selectedCategory notNil
						ifTrue: [ 
							self putSourceTextAreaLimit.
							self defaultMethodSource]
						ifFalse: [ self selectedClassDescription]]
				ifFalse: [ 
					self putSourceTextAreaLimit.
					self selectedMethodSource]].
		! !

!AbstractNautilusUIWithoutPackages methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
sourceCodeOkToChange

	sourceTextArea canDiscardEdits ifTrue: [^ true].
	sourceTextArea update: #wantToChange.  "Solicit cancel from view"
	^ sourceTextArea canDiscardEdits
! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
sourceCodeSymbol

	^ #SourceCode! !

!AbstractNautilusUIWithoutPackages methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
styled: aBoolean

	sourceTextArea ifNotNil: [:sta | 
		aBoolean 
			ifTrue: [ 
				self putSourceTextAreaLimit.
				sta beStyled ]
			ifFalse: [ 
				self removeSourceTextAreaLimit.
				sta beUnStyled ]]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
switchToByteCodeButton

	self sourceCodeOkToChange ifTrue: [ self currentDisplayChoice: self byteCodeSymbol ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
switchToDecompileButton

	self sourceCodeOkToChange ifTrue: [ self currentDisplayChoice: self decompileSymbol ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
switchToSourceCodeButton

	self sourceCodeOkToChange ifTrue: [ self currentDisplayChoice: self sourceCodeSymbol ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
systemNavigation

	^ SystemNavigation new 
			browsedEnvironment: self browsedEnvironment;
			yourself! !

!AbstractNautilusUIWithoutPackages methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
taskbarIcon

	^ self class icon! !

!AbstractNautilusUIWithoutPackages methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
testRunned: anAnnouncement

	| class correspondingClass |
	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [ ^ self ].
	
	
	class := anAnnouncement result.
	correspondingClass := anAnnouncement result correspondingClass.
	( class = self selectedClass or: [ correspondingClass = self selectedClass]) 
		ifTrue: [ 
			self removeClassFromMethodsIconsCache: class.
			self removeClassFromMethodsIconsCache: correspondingClass.
			self update ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
textMorphClass

	^ PluggableTextMorphWithLimits! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
title

	^'Nautilus'! !

!AbstractNautilusUIWithoutPackages methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
toogleButtonAction

	self selectedClass ifNil: [^self].
	self toogleShowPackages! !

!AbstractNautilusUIWithoutPackages methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
toogleButtonLabel

	^ 'Hierarchy'! !

!AbstractNautilusUIWithoutPackages methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
toogleButtonState

	^ self showPackages not! !

!AbstractNautilusUIWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
toogleShowComment

	self showComment: self showComment not! !

!AbstractNautilusUIWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
toogleShowGroups

	self showGroups: self showGroups not.! !

!AbstractNautilusUIWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
toogleShowHierarchy

	self showHierarchy: self showHierarchy not.
	self updateBothView
! !

!AbstractNautilusUIWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
toogleShowInstance
	^ self subclassResponsibility! !

!AbstractNautilusUIWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
toogleShowPackages

	self showPackages: self showPackages not.! !

!AbstractNautilusUIWithoutPackages methodsFor: 'announcement registration' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
unregisterAPlugin: aPlugin

	self announcer unsubscribe: aPlugin! !

!AbstractNautilusUIWithoutPackages methodsFor: 'announcement registration' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
unregisterAllPlugins

	self announcer subscriptions reset! !

!AbstractNautilusUIWithoutPackages methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
update! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
updateBothView

	self changed: #getList.
	self changed: #getList2! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
updateClassView

	self	
		ifPackages:  [ self changed: #getList2 ]
		ifClasses: [ self changed: #getList ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
updateGroupView

	self changed: #getList! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
updatePackageView

	| vScrollValue |
	self	
		ifPackages: [ self changed: #getList ]
		ifClasses: [ self changed: #getList2 ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
updatePackageViewContent

	| vScrollValue |
	self	
		ifPackages: [ 
			vScrollValue := list scrollValue y.
			self changed: #getList.
			list vScrollValue: vScrollValue ]
		ifClasses: [ 
			vScrollValue := list2 scrollValue y.
			self changed: #getList2.
			list2 vScrollValue: vScrollValue ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
warningLimit
	
	^ self model 
		ifNil: [ 350 ]
		ifNotNil: [:mod | model warningLimit ]! !

!AbstractNautilusUIWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
window

	^ window! !

!AbstractNautilusUIWithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:43'!
window: anObject

	window := anObject! !

AbstractNautilusUIWithoutPackages subclass: #NautilusUI2WithoutPackages
	instanceVariableNames: 'categoriesGroup methodsGroup methodsSelection categoriesSelection categoriesList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusWithoutPackages'!

!NautilusUI2WithoutPackages methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
addAll: aWindow
			
	| column row navigationRow topHeight middleHeight bottomMorph bottomHeight delta |
	delta := 0.
	bottomHeight := 0.
	middleHeight := 0.
	topHeight := 0.

	" reverse order in column ..."
	"column vResizing: #rigid."
	self buildTopPlugins ifNotNil: [:top |
		topHeight := top height.
		aWindow 
			addMorph: top
			fullFrame: (LayoutFrame 
							fractions: (0 @ 0 corner: 1 @ 0)
							offsets: (0 @ 0 corner: 0 @ topHeight)).
		delta := 4.
		topHeight := topHeight + delta.
		top color: Color transparent].
	
	"navigationRow := self buildNavigationRow: aWindow height: topHeight."

	self buildColumns: aWindow height: topHeight"+navigationRow".
	
	
	self buildMiddlePlugins ifNotNil: [:middle |
		middleHeight := middle height+4.
		aWindow 
			addMorph: middle
			fullFrame: (LayoutFrame 
							fractions: (0 @ 0.5 corner: 1 @ 0.5)
							offsets: (0 @ 0 corner: 0 @ middleHeight)).
		middle color: Color transparent].
	
	sourceCodePanel := PanelMorph new.
	sourceCodePanel 
		layoutPolicy: TableLayout new;
		listDirection: #bottomToTop.
		
	sourceCodePanel addMorph: self buildCodePane.
	"self buildCommentPane."
	sourceCodePanel 
		hResizing: #spaceFill;
		vResizing: #spaceFill.
	row := PanelMorph new.
	row 
		changeTableLayout;
		listDirection: #leftToRight.

	{	sourceCodePanel.
		self buildTextAreaButtonsColumn: aWindow} reverse do: [:each | row addMorph: each].
	
	bottomMorph := self buildBottomPlugins.
	bottomMorph ifNotNil: [:bottom | bottomHeight := bottom height + 8].
	aWindow
		addMorph: row
		fullFrame: (LayoutFrame 
						fractions: (0 @ 0.5 corner: 1 @ 1)
						offsets: (0 @ middleHeight corner: 0 @ bottomHeight negated)).
						
	bottomMorph ifNotNil: [:bottom |					
		aWindow				
			addMorph: bottom
			fullFrame: (LayoutFrame 
							fractions: (0 @ 1 corner: 1 @ 1)
							offsets: (0 @ bottomHeight negated corner: 0 @ 0)).
		bottom color: Color transparent]! !

!NautilusUI2WithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
addCategory

	"Present a choice of categories or prompt for a new category name and add it before the current selection, or at the end if no current selection"
	| newName |
	self okToChange ifFalse: [^ self].
	self selectedClass ifNil: [^ self].

	newName := self addCategoryIn: self selectedClass before: self selectedCategory.
	self resetCategoriesListSelection.
	self selectedCategory: newName.
	newName ifNil: [ ^ self ].
	self update.! !

!NautilusUI2WithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
allLabel

	^ '--- all ---'! !

!NautilusUI2WithoutPackages methodsFor: 'plugins display' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
buildBottomPlugins

	| bottom container |
	bottom := self model plugins select: [:each | each position = #bottom ].
	bottom ifEmpty: [ ^ nil ].
	bottom size = 1 ifTrue: [ ^ bottom first display ].
	container := Morph new.
	container 
		color: Color transparent;
		changeTableLayout;
		cellInset: 8;
		listDirection: #topToBottom;
		cellPositioning: #topLeft;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap.
	bottom reverse do: [:each |
		each display ifNotNil: [:morph | container addMorph: morph ]].
	^ container! !

!NautilusUI2WithoutPackages methodsFor: 'category-method list' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
buildCategoriesList

	categoriesList := PluggableIconListMorph
			on: self
			list: #getCategories
			primarySelection: #selectedCategoryIndex
			changePrimarySelection: #selectedCategoryIndex:
			listSelection: #categorySelectionAt:
			changeListSelection: #categorySelectionAt:put:
			menu: #categoriesMenu:shifted: 
			keystroke: #keyPressedOnCategory:.
			
	categoriesList resetListSelector: #resetCategoriesListSelection.
	categoriesList autoDeselect: true.	
	categoriesList wrapSelector: #categoryWrapper:.
	categoriesList 
		hResizing: #spaceFill;
		vResizing: #spaceFill.
	
	categoriesGroup := GroupboxMorph new
			addContentMorph: categoriesList;
			label: self categoriesLabel;
			hResizing: #spaceFill;
			vResizing: #spaceFill.
			
	^ categoriesGroup
	! !

!NautilusUI2WithoutPackages methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
buildColumns: aWindow height: height
			
	aWindow 
		addMorph: (self buildFirstColumn: aWindow)
		fullFrame: (LayoutFrame 
						fractions: (0 @ 0 corner: 0.25 @ 0.5)
						offsets: (0 @ height corner: 0 @ 0)).
						
	aWindow 
		addMorph: (self buildSecondColumn: aWindow)
		fullFrame: (LayoutFrame 
						fractions: (0.25 @ 0 corner: 0.5 @ 0.5)
						offsets: (0 @ height corner: 0 @ 0)).
						
	aWindow 
		addMorph: (self buildThirdColumn: aWindow)
		fullFrame: (LayoutFrame 
						fractions: (0.5 @ 0 corner: 0.75 @ 0.5)
						offsets: (0 @ height corner: 0 @ 0)).
						
	aWindow 
		addMorph: (self buildFourthColumn: aWindow)
		fullFrame: (LayoutFrame 
						fractions: (0.75 @ 0 corner: 1 @ 0.5)
						offsets: (0 @ height corner: 0 @ 0)).
		! !

!NautilusUI2WithoutPackages methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
buildFourthColumn: aWindow

	"^ (aWindow newColumn: {
		self buildLabelMorph.
		self buildList.
		aWindow newRow: {self buildToogleButton. self buildGroupsButton}}) 
		hResizing: #spaceFill; vResizing: #spaceFill"
		
	^ aWindow newColumn: {self buildMethodsList.self buildNextButton. }
			! !

!NautilusUI2WithoutPackages methodsFor: 'category-method list' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
buildMethodsList

	| listMorph |
	listMorph :=  PluggableIconListMorph
		on: self
		list: #getMethods
		primarySelection: #selectedMethodIndex
		changePrimarySelection: #selectedMethodIndex:
		listSelection: #methodSelectionAt:
		changeListSelection: #methodSelectionAt:put:
		menu: #elementsMenu:shifted: 
		keystroke: #keyPressedOnElement:.

	listMorph getIconSelector: #methodIconFor:.		
	listMorph resetListSelector: #resetMethodsListSelection.
	listMorph autoDeselect: true.	
	listMorph wrapSelector: #methodWrapper:.
	listMorph 
		hResizing: #spaceFill;
		vResizing: #spaceFill.
	
	methodsGroup := GroupboxMorph new
						addContentMorph: listMorph;
						label: self methodsLabel;
						hResizing: #spaceFill;
						vResizing: #spaceFill.
	^ methodsGroup! !

!NautilusUI2WithoutPackages methodsFor: 'plugins display' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
buildMiddlePlugins

	| middle container |
	middle := self model plugins select: [:each | each position = #middle ].
	middle ifEmpty: [ ^ nil ].
	middle size = 1 ifTrue: [ ^ middle first display ].
	container := Morph new.
	container 
		color: Color transparent;
		changeTableLayout;
		cellInset: 8;
		listDirection: #topToBottom;
		cellPositioning: #topLeft;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap.
	middle reverse do: [:each |
		each display ifNotNil: [:morph | container addMorph: morph ]].
	^ container! !

!NautilusUI2WithoutPackages methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
buildNavigationRow: aWindow height: height

	| row button |
	button := self buildPreviousButton.
	row := aWindow newRow: { button. self buildNextButton }.
	row
		vResizing: #rigid;
		hResizing: #spaceFill.
	row height: button minExtent y.
	aWindow
		addMorph: row
		fullFrame: (LayoutFrame 
						fractions: (0 @ 0 corner: 1 @ 0)
						offsets: (0 @ height corner: 0 @ (height + row height))).
						
	^ row height! !

!NautilusUI2WithoutPackages methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
buildNextButton

	^ (PluggableButtonMorph
			on: self 
			getState: #nextButtonState
			action: #nextButtonAction
			label: #nextButtonLabel) 
			hResizing: #spaceFill;
			vResizing: #shrinkWrap;
			getEnabledSelector: #nextButtonEnablementState;
			yourself! !

!NautilusUI2WithoutPackages methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
buildPreviousButton

	^ (PluggableButtonMorph
			on: self 
			getState: #previousButtonState
			action: #previousButtonAction
			label: #previousButtonLabel)
			hResizing: #spaceFill;
			vResizing: #shrinkWrap;
			getEnabledSelector: #previousButtonEnablementState;
			yourself! !

!NautilusUI2WithoutPackages methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
buildThirdColumn: aWindow

	"^ (aWindow newColumn: {
		self buildLabelMorph.
		self buildList.
		aWindow newRow: {self buildToogleButton. self buildGroupsButton}}) 
		hResizing: #spaceFill; vResizing: #spaceFill"
		
	^ aWindow newColumn: {self buildCategoriesList.self buildPreviousButton. }
			! !

!NautilusUI2WithoutPackages methodsFor: 'plugins display' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
buildTopPlugins

	| top container |
	top := self model plugins select: [:each | each position = #top ].
	top ifEmpty: [ ^ nil ].
	top size = 1 ifTrue: [ ^ top first display ].
	container := Morph new.
	container 
		color: Color transparent;
		changeTableLayout;
		cellInset: 8;
		listDirection: #topToBottom;
		cellPositioning: #topLeft;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap.
	top reverse do: [:each |
		each display ifNotNil: [:morph | container addMorph: morph ]].
	^ container! !

!NautilusUI2WithoutPackages methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
categoriesMenu: aBuilder
	
	self selectedCategory ifNil: [ ^ self ].
	
	(aBuilder item: #'Rename... (r)')
		action: [ self renameCategory ];
		order: 1000;
		enabledBlock: [ self enableCategorySingleSelection ].
		
	(aBuilder item: #'Remove empty protocols')
		action: [ self removeEmptyCategories ];
		order: 1100.
		
	(aBuilder item: #'Remove... (x)')
		action: [ self removeCategories ];
		order: 1200;
		icon: (self iconClass iconNamed: #removeIcon);
		withSeparatorAfter.
		
		(aBuilder item: #'File Out')
		action: [ self fileOutMethods ];
		order: 1300.! !

!NautilusUI2WithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
categorizeMethod

	"Present a choice of categories or prompt for a new category name and add it before the current selection, or at the end if no current selection"
	| aCollection aClass |
	self okToChange ifFalse: [^ self].
	(aCollection := self selectedMethods) ifEmpty: [^ self].
	(aClass := self selectedClass) ifNil: [^self].	

	self categorizeMethods: aCollection of: aClass from: self selectedCategory.

	self update.! !

!NautilusUI2WithoutPackages methodsFor: 'category-method list' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
categorySelectionAt: anIndex

	| elt |
	elt := self getCategories at: anIndex ifAbsent: [ nil ].
	^ categoriesSelection at: elt ifAbsent: [ false ].! !

!NautilusUI2WithoutPackages methodsFor: 'category-method list' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
categorySelectionAt: anIndex put: aBoolean

	| elt |
	elt := self getCategories at: anIndex ifAbsent: [ nil ].
	^ categoriesSelection at: elt put: aBoolean! !

!NautilusUI2WithoutPackages methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
compileAMethodFromCategory: aCategory withSource: aString notifying: aController

	| category selector |
	category := aCategory.
	self selectedClass
		ifNil: ["should never happened" self error]
		ifNotNil: [:class || cat |
			cat := category.
			(category = self noMethodsString or: [ category = self allLabel ])
				ifTrue: [ cat := self asYetUnclassifiedString ].
			selector := self compileANewMethodInClass: class categorized: cat from: aString notifyng: aController.
			selector
				ifNil: [^ self ]
				ifNotNil: [| method |
					sourceTextArea update: #clearUserEdits.
					method := class methodDict at: selector.
					"self selectedCategory: cat."
					"methodsTree setSelectedNodeItem: method."
					( self selectedMethod notNil and: [(self selectedClass = class) and: [ self selectedMethod selector = selector]])
						ifFalse: [
							self selectedMethod: method.
							self update]]]! !

!NautilusUI2WithoutPackages methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
compileSource: aText notifying: aController

	| source category method |
	source := aText asString.
	category := self selectedCategory.
	method := self selectedMethod.
	category ifNil: [ method ifNotNil: [ category := method protocol ]].
	(category isNil and: [ method isNil ])
		ifTrue: [ self compileAClassFrom: source ]
		ifFalse: [ | cat |
			((category = self allLabel) and: [ self selectedMethod notNil ])
				ifTrue: [ cat := self selectedMethod protocol ]
				ifFalse: [ cat := category ].
			self compileAMethodFromCategory: cat withSource: source notifying: aController ]! !

!NautilusUI2WithoutPackages methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
elementsMenu: aBuilder

	self selectedMethod ifNil: [ ^ self ].
	
	(aBuilder item: #'Senders of...(n)')
		action: [ self browseSendersOfMessages ];
		order: 1000;
		enabledBlock: [ self enableMethodSingleSelection ].
		
	(aBuilder item: #'Implementors of... (m)')
		action: [ self browseMessages ];
		order: 1100;
		enabledBlock: [ self enableMethodSingleSelection ].
		
	(aBuilder item: #'Inheritance (i)')
		action: [ self methodHierarchy ];
		order: 1200;
		enabledBlock: [ self enableMethodSingleSelection ].
		
	(aBuilder item: #'Versions (v)')
		action: [ self browseVersions ];
		order: 1300;
		enabledBlock: [ self enableMethodSingleSelection ];
		withSeparatorAfter.
	
	(aBuilder item: #'Categorize method (C)')
		action: [ self categorizeMethod ];
		order: 1400.
		
	(aBuilder item: #'Move to package...')
		action: [ self moveMethodToPackage ];
		order: 1500.
		
	(aBuilder item: #'Remove... (x)')
		action: [ self removeMethods ];
		order: 1600;
		icon: (self iconClass iconNamed: #removeIcon);
		withSeparatorAfter.
		
	(aBuilder item: #'File Out')
		action: [ self fileOutMethods ];
		order: 1700
	! !

!NautilusUI2WithoutPackages methodsFor: 'category-method list' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
enableCategorySingleSelection

	^ self selectedCategories size <= 1! !

!NautilusUI2WithoutPackages methodsFor: 'category-method list' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
enableMethodSingleSelection

	^ self selectedMethods size <= 1! !

!NautilusUI2WithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
fileOutMethods

	self fileOutMethods: self selectedMethods! !

!NautilusUI2WithoutPackages methodsFor: 'category-method methods' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
forceSelectedMethod: aMethod 
	
	self model package: self selectedPackage class: self selectedClass category: self selectedCategory method: aMethod.! !

!NautilusUI2WithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
forceSelection: aNode
! !

!NautilusUI2WithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
fullBrowse

	self model class 
		openOnPackage: self selectedPackage
		class: self selectedClass
		category: self selectedCategory
		method: self selectedMethod
		group: self selectedGroup
		showGroups: self showGroups
		showHierarchy: self showHierarchy
		showPackages: self showPackages
		showComment: self showComment 
		showInstance: self showInstance 
		showCategories: true
! !

!NautilusUI2WithoutPackages methodsFor: 'category-method list' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
getCategories

	^ self model selectedClass
		ifNil: [ {} ]
		ifNotNil: [:class | class organization categories copy sort asOrderedCollection addFirst: self allLabel; yourself ]! !

!NautilusUI2WithoutPackages methodsFor: 'category-method list' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
getMethods

	^ self model selectedCategory
		ifNil: [ self methodsForCategory: self allLabel ]
		ifNotNil: [:cat | self methodsForCategory: cat ]! !

!NautilusUI2WithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
highlightCategory: aMethod.
			
		aMethod 
			ifNil: [ categoriesList searchedElement: self selectedCategoryIndex]
			ifNotNil: [ | category index |
				category := aMethod protocol.
				index := self getCategories indexOf: ( category ).
				categoriesList searchedElement: index ]! !

!NautilusUI2WithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
initialize

	super initialize.
	categoriesSelection := Dictionary new.
	methodsSelection := Dictionary new.! !

!NautilusUI2WithoutPackages methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
keyPressedOnCategory: anEvent

	anEvent == $b
		ifTrue: [ ^ self fullBrowse ].
		
	anEvent == $f
		ifTrue: [ ^ self findMethod ].
		
	anEvent == $n
		ifTrue: [ ^ self addCategory ].
			
	(anEvent == $r and:[ self enableCategorySingleSelection ])
		ifTrue: [ ^ self renameCategory ].
		
	anEvent == $x
		ifTrue: [ ^ self removeCategories ].
	! !

!NautilusUI2WithoutPackages methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
keyPressedOnElement: anEvent

	anEvent == $b
		ifTrue: [ ^ self fullBrowse ].
		
	anEvent == $f
		ifTrue: [ ^ self findMethod ].
		
	(anEvent == $n and:[ self enableMethodSingleSelection ])
		ifTrue: [ ^ self browseSendersOfMessages ].
		
	(anEvent == $m and:[ self enableMethodSingleSelection ])
		ifTrue: [ ^ self browseMessages ].
		
	(anEvent == $i and:[ self enableMethodSingleSelection ])
		ifTrue: [ ^ self methodHierarchy ].
		
	(anEvent == $v and:[ self enableMethodSingleSelection ])
		ifTrue: [ ^ self browseVersions ].
		
	anEvent == $C
		ifTrue: [ ^ self categorizeMethod ].
		
	(anEvent == $t)
		ifTrue: [ ^ self runTestFor: {self selectedMethods} ].

	anEvent == $x
		ifTrue: [ ^ self removeMethods ].! !

!NautilusUI2WithoutPackages methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
methodAdded: anAnnouncement
	
	| method |
	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [ ^ self ].
	
	method := anAnnouncement item.
	(method methodClass = self selectedClass)
		ifTrue: [ 
			self resetMethodsListSelection.
			self removeAllFromMethodsIconsCache: method.
			self update ]! !

!NautilusUI2WithoutPackages methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
methodRemoved: anAnnouncement
	
	| method |
	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [ ^ self ].
		
	method := anAnnouncement item.
	(method methodClass = self selectedClass)
		ifTrue: [ 
			self selectedMethod = anAnnouncement item
				ifTrue: [ self selectedMethod: nil ].
			self resetMethodsListSelection.
			self removeAllFromMethodsIconsCache: method.
			self update ]! !

!NautilusUI2WithoutPackages methodsFor: 'category-method list' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
methodSelectionAt: anIndex

	| elt assoc |
	elt := self getMethods at: anIndex ifAbsent: [ ^ false ].
	
	(methodsSelection keys identityIncludes: elt) ifFalse: [ ^ false].
	
	assoc := methodsSelection associationAt: elt ifAbsent: [ ^ false ].
	assoc key selector = elt selector 
		ifTrue: [ ^ assoc value ]
		ifFalse: [ ^ false ]! !

!NautilusUI2WithoutPackages methodsFor: 'category-method list' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
methodSelectionAt: anIndex put: aBoolean

	| elt result |
	"self haltIf: [ anIndex = 6 ]."
	elt := self getMethods at: anIndex ifAbsent: [ ^ self ].
	methodsSelection at: elt put: aBoolean.! !

!NautilusUI2WithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
methodsForCategory: aCategory

	self selectedClass ifNil: [ ^ {} ].
	
	aCategory = self allLabel
		ifTrue: [ ^ self selectedClass methodDict values sort: [:a :b | a selector <= b selector ]].
	
	^ (self selectedClass organization listAtCategoryNamed: aCategory) collect: [:each | self selectedClass methodDict at: each ]! !

!NautilusUI2WithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
moveMethodToPackage
	"Search for a package from a pattern or from the recent list"	
	
	| packagesList  |	
	self okToChange ifFalse: [^ self flashPackage ].
	packagesList := self model packages collect: [:each | each name ].
	
	self moveMethodsToPackage: self selectedMethods in: packagesList  from: self selectedPackage.

	self update.
		
! !

!NautilusUI2WithoutPackages methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
nextButtonAction

	self model next! !

!NautilusUI2WithoutPackages methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
nextButtonEnablementState

	^ self model hasNext! !

!NautilusUI2WithoutPackages methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
nextButtonLabel

	^ '>'! !

!NautilusUI2WithoutPackages methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
nextButtonState

	^ false! !

!NautilusUI2WithoutPackages methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
previousButtonAction

	self model previous! !

!NautilusUI2WithoutPackages methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
previousButtonEnablementState

	^ self model hasPrevious! !

!NautilusUI2WithoutPackages methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
previousButtonLabel

	^ '<'! !

!NautilusUI2WithoutPackages methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
previousButtonState

	^ false! !

!NautilusUI2WithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
removeCategories

	self selectedClass 
		ifNotNil: [:class |
			self selectedCategories
				ifNotEmpty: [:items || removeACategory |
					removeACategory := false.
					items do: [:item || needToUpdate |
						needToUpdate := self removeCategory: item inClass: class.
						(needToUpdate and: [ removeACategory not ]) ifTrue: [ removeACategory := true].
						needToUpdate ifTrue: [ self update ]].

					removeACategory ifTrue: [ self selectedCategory: nil ].
					self update ]]
! !

!NautilusUI2WithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
removeMethods

	self selectedClass 
		ifNotNil: [:class |
			self selectedMethods
				ifNotEmpty: [:items || removeAMethod |
					removeAMethod := false.
					items do: [:item || b needToUpdate |
					needToUpdate := self removeMethod: item inClass: class.
					(needToUpdate and: [ removeAMethod not ]) ifTrue: [ removeAMethod := true].
					needToUpdate.
					needToUpdate ifTrue: [ 
						self resetMethodsListSelection.
						self changed: #getMethods.  ]].
					
					removeAMethod ifTrue: [ self selectedMethod: nil ].
					self resetMethodsListSelection.
					self changed: #getMethods. ]]! !

!NautilusUI2WithoutPackages methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
renameCategory
	"Prompt for a new category name and add it before the
	current selection, or at the end if no current selection"

	| newName |	
	self okToChange ifFalse: [^ self].

	newName := self renameCategory: self selectedCategory from: self selectedClass.
	
	self selectedCategory: newName.
	self update.! !

!NautilusUI2WithoutPackages methodsFor: 'category-method list' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
resetCategoriesListSelection

	categoriesSelection removeAll! !

!NautilusUI2WithoutPackages methodsFor: 'category-method list' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
resetMethodsListSelection

	methodsSelection removeAll! !

!NautilusUI2WithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
resetSelections

	self resetListSelection.
	self resetListSelection2.
	self resetCategoriesListSelection.
	self resetMethodsListSelection.! !

!NautilusUI2WithoutPackages methodsFor: 'icons behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
runClassTests

	self selectedClasses
		ifNotEmpty:[:classes | 
			classes do: [:class | self runTestsOfClass: class ]]! !

!NautilusUI2WithoutPackages methodsFor: 'icons behavior' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
runTestsOfClass: aClass 
	
	aClass methodDict do: [:method | 
		method isTestMethod
			ifTrue: [ self runTestForAMethod: method ]].
	self popUpTestsResult: aClass correspondingTestClass ! !

!NautilusUI2WithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
selectedCategories

	| associations |
	associations := categoriesSelection associations select: [:assoc | assoc value ].
	associations := associations collect: [:assoc | assoc key ].
	^ associations select: [:each | each notNil ]! !

!NautilusUI2WithoutPackages methodsFor: 'category-method methods' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
selectedCategory: anObject

	self okToChange
		ifTrue: [
			self model package: self selectedPackage class: self selectedClass category: anObject method: nil.
			self resetMethodsListSelection.
			self changed: #sourceCode.
			^ true].
	^ false! !

!NautilusUI2WithoutPackages methodsFor: 'category-method methods' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
selectedCategoryIndex

	^ self getCategories indexOf: self selectedCategory ifAbsent: [ 0 ]! !

!NautilusUI2WithoutPackages methodsFor: 'category-method methods' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
selectedCategoryIndex: anInteger

	| anObject |
	anObject := self getCategories at: anInteger ifAbsent: [ nil ].
	self selectedCategory: anObject.
	
	self changed: #selectedCategoryIndex.
	self changed: #getMethods.! !

!NautilusUI2WithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
selectedClassWithoutChangingSelection: aClass 

	self okToChange
		ifTrue: [| package packageChanged |
			package := self selectedPackage.
			(self showPackages not or: [self showGroups ])
				ifTrue: [ aClass ifNotNil: [ package := aClass package ]].
			aClass 
				ifNil: [ classesSelection removeAll ].
			packageChanged := (package ~= self selectedPackage).
			self model package: package class: aClass category: nil method: nil.
			self setWindowTitle.
			
			packageChanged ifTrue: [
				packagesSelection removeAll.
				packagesSelection at: package put: true.
				self showGroups
					ifTrue: [ self updateClassView ]
					ifFalse: [ self updateBothView ]].
				
			self resetCategoriesListSelection.
			self resetMethodsListSelection.
			self update.
			self changed: #isAClassSelected.
			self changed: #getComments.
			self changed: #sourceCode]! !

!NautilusUI2WithoutPackages methodsFor: 'category-method methods' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
selectedMethod: aMethod 

	self okToChange
		ifTrue: [
			self forceSelectedMethod: aMethod.
			self setWindowTitle.
			self highlightCategory: aMethod.
			
			self changed: #sourceCode.
			^ true].
	^false ! !

!NautilusUI2WithoutPackages methodsFor: 'category-method methods' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
selectedMethodIndex
"self halt."
	^ self getMethods identityIndexOf: self selectedMethod ifAbsent: [ 0 ].! !

!NautilusUI2WithoutPackages methodsFor: 'category-method methods' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
selectedMethodIndex: anInteger

	| aMethod |
	aMethod :=  self getMethods at: anInteger ifAbsent: [ nil ].
	self selectedMethod: aMethod.

	self changed: #selectedMethodIndex.! !

!NautilusUI2WithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
selectedMethods

	| associations |
	associations := methodsSelection associations select: [:assoc | assoc value ].
	associations := associations collect: [:assoc | assoc key ].
	^ associations select: [:each | each notNil ]! !

!NautilusUI2WithoutPackages methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
toogleShowInstance

	self showInstance: self showInstance not.
	categoriesGroup label: self categoriesLabel.
	methodsGroup label: self methodsLabel.! !

!NautilusUI2WithoutPackages methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/20/2011 14:42'!
update

"	self resetCategoriesListSelection.
	self resetMethodsListSelection."
	self changed: #getCategories.
	self changed: #getMethods.! !
AbstractNautilusUIWithoutPackages initialize!
NautilusWithoutPackages initialize!
